"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SecretStorage = exports.SECRET_STORAGE_ALGORITHM_V1_AES = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _events = require("events");

var _logger = require("../logger");

var olmlib = _interopRequireWildcard(require("./olmlib"));

var _randomstring = require("../randomstring");

var _aes = require("./aes");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var SECRET_STORAGE_ALGORITHM_V1_AES = "m.secret_storage.v1.aes-hmac-sha2";
exports.SECRET_STORAGE_ALGORITHM_V1_AES = SECRET_STORAGE_ALGORITHM_V1_AES;
var ZERO_STR = "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
/**
 * Implements Secure Secret Storage and Sharing (MSC1946)
 * @module crypto/SecretStorage
 */

var SecretStorage = /*#__PURE__*/function (_EventEmitter) {
  (0, _inherits2["default"])(SecretStorage, _EventEmitter);

  var _super = _createSuper(SecretStorage);

  function SecretStorage(baseApis, cryptoCallbacks) {
    var _this;

    (0, _classCallCheck2["default"])(this, SecretStorage);
    _this = _super.call(this);
    _this._baseApis = baseApis;
    _this._cryptoCallbacks = cryptoCallbacks;
    _this._requests = {};
    _this._incomingRequests = {};
    return _this;
  }

  (0, _createClass2["default"])(SecretStorage, [{
    key: "getDefaultKeyId",
    value: function () {
      var _getDefaultKeyId = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var defaultKey;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._baseApis.getAccountDataFromServer('m.secret_storage.default_key');

              case 2:
                defaultKey = _context.sent;

                if (defaultKey) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt("return", null);

              case 5:
                return _context.abrupt("return", defaultKey.key);

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getDefaultKeyId() {
        return _getDefaultKeyId.apply(this, arguments);
      }

      return getDefaultKeyId;
    }()
  }, {
    key: "setDefaultKeyId",
    value: function setDefaultKeyId(keyId) {
      var _this2 = this;

      return new Promise( /*#__PURE__*/function () {
        var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve, reject) {
          var listener;
          return _regenerator["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  listener = function listener(ev) {
                    if (ev.getType() === 'm.secret_storage.default_key' && ev.getContent().key === keyId) {
                      _this2._baseApis.removeListener('accountData', listener);

                      resolve();
                    }
                  };

                  _this2._baseApis.on('accountData', listener);

                  _context2.prev = 2;
                  _context2.next = 5;
                  return _this2._baseApis.setAccountData('m.secret_storage.default_key', {
                    key: keyId
                  });

                case 5:
                  _context2.next = 11;
                  break;

                case 7:
                  _context2.prev = 7;
                  _context2.t0 = _context2["catch"](2);

                  _this2._baseApis.removeListener('accountData', listener);

                  reject(_context2.t0);

                case 11:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, null, [[2, 7]]);
        }));

        return function (_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }());
    }
    /**
     * Add a key for encrypting secrets.
     *
     * @param {string} algorithm the algorithm used by the key.
     * @param {object} opts the options for the algorithm.  The properties used
     *     depend on the algorithm given.
     * @param {string} [keyId] the ID of the key.  If not given, a random
     *     ID will be generated.
     *
     * @return {object} An object with:
     *     keyId: {string} the ID of the key
     *     keyInfo: {object} details about the key (iv, mac, passphrase)
     */

  }, {
    key: "addKey",
    value: function () {
      var _addKey = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(algorithm, opts, keyId) {
        var keyInfo, _yield$SecretStorage$, iv, mac;

        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                keyInfo = {
                  algorithm: algorithm
                };
                if (!opts) opts = {};

                if (opts.name) {
                  keyInfo.name = opts.name;
                }

                if (!(algorithm === SECRET_STORAGE_ALGORITHM_V1_AES)) {
                  _context3.next = 15;
                  break;
                }

                if (opts.passphrase) {
                  keyInfo.passphrase = opts.passphrase;
                }

                if (!opts.key) {
                  _context3.next = 13;
                  break;
                }

                _context3.next = 8;
                return SecretStorage._calculateKeyCheck(opts.key);

              case 8:
                _yield$SecretStorage$ = _context3.sent;
                iv = _yield$SecretStorage$.iv;
                mac = _yield$SecretStorage$.mac;
                keyInfo.iv = iv;
                keyInfo.mac = mac;

              case 13:
                _context3.next = 16;
                break;

              case 15:
                throw new Error("Unknown key algorithm ".concat(opts.algorithm));

              case 16:
                if (keyId) {
                  _context3.next = 21;
                  break;
                }

              case 17:
                keyId = (0, _randomstring.randomString)(32);

              case 18:
                _context3.next = 20;
                return this._baseApis.getAccountDataFromServer("m.secret_storage.key.".concat(keyId));

              case 20:
                if (_context3.sent) {
                  _context3.next = 17;
                  break;
                }

              case 21:
                _context3.next = 23;
                return this._baseApis.setAccountData("m.secret_storage.key.".concat(keyId), keyInfo);

              case 23:
                return _context3.abrupt("return", {
                  keyId: keyId,
                  keyInfo: keyInfo
                });

              case 24:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function addKey(_x3, _x4, _x5) {
        return _addKey.apply(this, arguments);
      }

      return addKey;
    }()
    /**
     * Get the key information for a given ID.
     *
     * @param {string} [keyId = default key's ID] The ID of the key to check
     *     for. Defaults to the default key ID if not provided.
     * @returns {Array?} If the key was found, the return value is an array of
     *     the form [keyId, keyInfo].  Otherwise, null is returned.
     */

  }, {
    key: "getKey",
    value: function () {
      var _getKey = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(keyId) {
        var keyInfo;
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (keyId) {
                  _context4.next = 4;
                  break;
                }

                _context4.next = 3;
                return this.getDefaultKeyId();

              case 3:
                keyId = _context4.sent;

              case 4:
                if (keyId) {
                  _context4.next = 6;
                  break;
                }

                return _context4.abrupt("return", null);

              case 6:
                _context4.next = 8;
                return this._baseApis.getAccountDataFromServer("m.secret_storage.key." + keyId);

              case 8:
                keyInfo = _context4.sent;
                return _context4.abrupt("return", keyInfo ? [keyId, keyInfo] : null);

              case 10:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getKey(_x6) {
        return _getKey.apply(this, arguments);
      }

      return getKey;
    }()
    /**
     * Check whether we have a key with a given ID.
     *
     * @param {string} [keyId = default key's ID] The ID of the key to check
     *     for. Defaults to the default key ID if not provided.
     * @return {boolean} Whether we have the key.
     */

  }, {
    key: "hasKey",
    value: function () {
      var _hasKey = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(keyId) {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.getKey(keyId);

              case 2:
                return _context5.abrupt("return", !!_context5.sent);

              case 3:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function hasKey(_x7) {
        return _hasKey.apply(this, arguments);
      }

      return hasKey;
    }()
    /**
     * Check whether a key matches what we expect based on the key info
     *
     * @param {Uint8Array} key the key to check
     * @param {object} info the key info
     *
     * @return {boolean} whether or not the key matches
     */

  }, {
    key: "checkKey",
    value: function () {
      var _checkKey = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(key, info) {
        var _yield$SecretStorage$2, mac;

        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                if (!(info.algorithm === SECRET_STORAGE_ALGORITHM_V1_AES)) {
                  _context6.next = 12;
                  break;
                }

                if (!info.mac) {
                  _context6.next = 9;
                  break;
                }

                _context6.next = 4;
                return SecretStorage._calculateKeyCheck(key, info.iv);

              case 4:
                _yield$SecretStorage$2 = _context6.sent;
                mac = _yield$SecretStorage$2.mac;
                return _context6.abrupt("return", info.mac.replace(/=+$/g, '') === mac.replace(/=+$/g, ''));

              case 9:
                return _context6.abrupt("return", true);

              case 10:
                _context6.next = 13;
                break;

              case 12:
                throw new Error("Unknown algorithm");

              case 13:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }));

      function checkKey(_x8, _x9) {
        return _checkKey.apply(this, arguments);
      }

      return checkKey;
    }()
  }, {
    key: "store",

    /**
     * Store an encrypted secret on the server
     *
     * @param {string} name The name of the secret
     * @param {string} secret The secret contents.
     * @param {Array} keys The IDs of the keys to use to encrypt the secret
     *     or null/undefined to use the default key.
     */
    value: function () {
      var _store = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(name, secret, keys) {
        var encrypted, defaultKeyId, _iterator, _step, keyId, keyInfo, _keys, _yield$this$_getSecre, _yield$this$_getSecre2, encryption;

        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                encrypted = {};

                if (keys) {
                  _context7.next = 8;
                  break;
                }

                _context7.next = 4;
                return this.getDefaultKeyId();

              case 4:
                defaultKeyId = _context7.sent;

                if (defaultKeyId) {
                  _context7.next = 7;
                  break;
                }

                throw new Error("No keys specified and no default key present");

              case 7:
                keys = [defaultKeyId];

              case 8:
                if (!(keys.length === 0)) {
                  _context7.next = 10;
                  break;
                }

                throw new Error("Zero keys given to encrypt with!");

              case 10:
                _iterator = _createForOfIteratorHelper(keys);
                _context7.prev = 11;

                _iterator.s();

              case 13:
                if ((_step = _iterator.n()).done) {
                  _context7.next = 35;
                  break;
                }

                keyId = _step.value;
                _context7.next = 17;
                return this._baseApis.getAccountDataFromServer("m.secret_storage.key." + keyId);

              case 17:
                keyInfo = _context7.sent;

                if (keyInfo) {
                  _context7.next = 20;
                  break;
                }

                throw new Error("Unknown key: " + keyId);

              case 20:
                if (!(keyInfo.algorithm === SECRET_STORAGE_ALGORITHM_V1_AES)) {
                  _context7.next = 32;
                  break;
                }

                _keys = (0, _defineProperty2["default"])({}, keyId, keyInfo);
                _context7.next = 24;
                return this._getSecretStorageKey(_keys, name);

              case 24:
                _yield$this$_getSecre = _context7.sent;
                _yield$this$_getSecre2 = (0, _slicedToArray2["default"])(_yield$this$_getSecre, 2);
                encryption = _yield$this$_getSecre2[1];
                _context7.next = 29;
                return encryption.encrypt(secret);

              case 29:
                encrypted[keyId] = _context7.sent;
                _context7.next = 33;
                break;

              case 32:
                _logger.logger.warn("unknown algorithm for secret storage key " + keyId + ": " + keyInfo.algorithm); // do nothing if we don't understand the encryption algorithm


              case 33:
                _context7.next = 13;
                break;

              case 35:
                _context7.next = 40;
                break;

              case 37:
                _context7.prev = 37;
                _context7.t0 = _context7["catch"](11);

                _iterator.e(_context7.t0);

              case 40:
                _context7.prev = 40;

                _iterator.f();

                return _context7.finish(40);

              case 43:
                _context7.next = 45;
                return this._baseApis.setAccountData(name, {
                  encrypted: encrypted
                });

              case 45:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this, [[11, 37, 40, 43]]);
      }));

      function store(_x10, _x11, _x12) {
        return _store.apply(this, arguments);
      }

      return store;
    }()
    /**
     * Temporary method to fix up existing accounts where secrets
     * are incorrectly stored without the 'encrypted' level
     *
     * @param {string} name The name of the secret
     * @param {object} secretInfo The account data object
     * @returns {object} The fixed object or null if no fix was performed
     */

  }, {
    key: "_fixupStoredSecret",
    value: function () {
      var _fixupStoredSecret2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(name, secretInfo) {
        var keys, hasKey, newData;
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                // We assume the secret was only stored passthrough for 1
                // key - this was all the broken code supported.
                keys = Object.keys(secretInfo);

                if (!(keys.length === 1 && keys[0] !== 'encrypted' && secretInfo[keys[0]].passthrough)) {
                  _context8.next = 13;
                  break;
                }

                _context8.next = 4;
                return this.hasKey(keys[0]);

              case 4:
                hasKey = _context8.sent;

                if (!hasKey) {
                  _context8.next = 13;
                  break;
                }

                _logger.logger.log("Fixing up passthrough secret: " + name);

                _context8.next = 9;
                return this.storePassthrough(name, keys[0]);

              case 9:
                _context8.next = 11;
                return this._baseApis.getAccountDataFromServer(name);

              case 11:
                newData = _context8.sent;
                return _context8.abrupt("return", newData);

              case 13:
                return _context8.abrupt("return", null);

              case 14:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function _fixupStoredSecret(_x13, _x14) {
        return _fixupStoredSecret2.apply(this, arguments);
      }

      return _fixupStoredSecret;
    }()
    /**
     * Get a secret from storage.
     *
     * @param {string} name the name of the secret
     *
     * @return {string} the contents of the secret
     */

  }, {
    key: "get",
    value: function () {
      var _get = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(name) {
        var secretInfo, keys, _i, _Object$keys, _keyId, keyInfo, encInfo, keyId, decryption, _yield$this$_getSecre3, _yield$this$_getSecre4, _encInfo;

        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this._baseApis.getAccountDataFromServer(name);

              case 2:
                secretInfo = _context9.sent;

                if (secretInfo) {
                  _context9.next = 5;
                  break;
                }

                return _context9.abrupt("return");

              case 5:
                if (secretInfo.encrypted) {
                  _context9.next = 11;
                  break;
                }

                _context9.next = 8;
                return this._fixupStoredSecret(name, secretInfo);

              case 8:
                secretInfo = _context9.sent;

                if (!(!secretInfo || !secretInfo.encrypted)) {
                  _context9.next = 11;
                  break;
                }

                throw new Error("Content is not encrypted!");

              case 11:
                // get possible keys to decrypt
                keys = {};
                _i = 0, _Object$keys = Object.keys(secretInfo.encrypted);

              case 13:
                if (!(_i < _Object$keys.length)) {
                  _context9.next = 23;
                  break;
                }

                _keyId = _Object$keys[_i];
                _context9.next = 17;
                return this._baseApis.getAccountDataFromServer("m.secret_storage.key." + _keyId);

              case 17:
                keyInfo = _context9.sent;
                encInfo = secretInfo.encrypted[_keyId]; // only use keys we understand the encryption algorithm of

                if (keyInfo.algorithm === SECRET_STORAGE_ALGORITHM_V1_AES) {
                  if (encInfo.iv && encInfo.ciphertext && encInfo.mac) {
                    keys[_keyId] = keyInfo;
                  }
                }

              case 20:
                _i++;
                _context9.next = 13;
                break;

              case 23:
                if (!(Object.keys(keys).length === 0)) {
                  _context9.next = 25;
                  break;
                }

                throw new Error("Could not decrypt ".concat(name, " because none of ") + "the keys it is encrypted with are for a supported algorithm");

              case 25:
                _context9.prev = 25;
                _context9.next = 28;
                return this._getSecretStorageKey(keys, name);

              case 28:
                _yield$this$_getSecre3 = _context9.sent;
                _yield$this$_getSecre4 = (0, _slicedToArray2["default"])(_yield$this$_getSecre3, 2);
                keyId = _yield$this$_getSecre4[0];
                decryption = _yield$this$_getSecre4[1];
                _encInfo = secretInfo.encrypted[keyId]; // We don't actually need the decryption object if it's a passthrough
                // since we just want to return the key itself. It must be base64
                // encoded, since this is how a key would normally be stored.

                if (!_encInfo.passthrough) {
                  _context9.next = 35;
                  break;
                }

                return _context9.abrupt("return", (0, olmlib.encodeBase64)(decryption.get_private_key()));

              case 35:
                _context9.next = 37;
                return decryption.decrypt(_encInfo);

              case 37:
                return _context9.abrupt("return", _context9.sent);

              case 38:
                _context9.prev = 38;
                if (decryption && decryption.free) decryption.free();
                return _context9.finish(38);

              case 41:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this, [[25,, 38, 41]]);
      }));

      function get(_x15) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
    /**
     * Check if a secret is stored on the server.
     *
     * @param {string} name the name of the secret
     * @param {boolean} checkKey check if the secret is encrypted by a trusted key
     *
     * @return {object?} map of key name to key info the secret is encrypted
     *     with, or null if it is not present or not encrypted with a trusted
     *     key
     */

  }, {
    key: "isStored",
    value: function () {
      var _isStored = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(name, checkKey) {
        var secretInfo, ret, _i2, _Object$keys2, keyId, keyInfo, encInfo;

        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this._baseApis.getAccountDataFromServer(name);

              case 2:
                secretInfo = _context10.sent;

                if (secretInfo) {
                  _context10.next = 5;
                  break;
                }

                return _context10.abrupt("return", null);

              case 5:
                if (secretInfo.encrypted) {
                  _context10.next = 11;
                  break;
                }

                _context10.next = 8;
                return this._fixupStoredSecret(name, secretInfo);

              case 8:
                secretInfo = _context10.sent;

                if (!(!secretInfo || !secretInfo.encrypted)) {
                  _context10.next = 11;
                  break;
                }

                return _context10.abrupt("return", null);

              case 11:
                if (checkKey === undefined) checkKey = true;
                ret = {}; // filter secret encryption keys with supported algorithm

                _i2 = 0, _Object$keys2 = Object.keys(secretInfo.encrypted);

              case 14:
                if (!(_i2 < _Object$keys2.length)) {
                  _context10.next = 26;
                  break;
                }

                keyId = _Object$keys2[_i2];
                _context10.next = 18;
                return this._baseApis.getAccountDataFromServer("m.secret_storage.key." + keyId);

              case 18:
                keyInfo = _context10.sent;

                if (keyInfo) {
                  _context10.next = 21;
                  break;
                }

                return _context10.abrupt("continue", 23);

              case 21:
                encInfo = secretInfo.encrypted[keyId]; // only use keys we understand the encryption algorithm of

                if (keyInfo.algorithm === SECRET_STORAGE_ALGORITHM_V1_AES) {
                  if (encInfo.iv && encInfo.ciphertext && encInfo.mac) {
                    ret[keyId] = keyInfo;
                  }
                }

              case 23:
                _i2++;
                _context10.next = 14;
                break;

              case 26:
                return _context10.abrupt("return", Object.keys(ret).length ? ret : null);

              case 27:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function isStored(_x16, _x17) {
        return _isStored.apply(this, arguments);
      }

      return isStored;
    }()
    /**
     * Request a secret from another device
     *
     * @param {string} name the name of the secret to request
     * @param {string[]} devices the devices to request the secret from
     *
     * @return {string} the contents of the secret
     */

  }, {
    key: "request",
    value: function request(name, devices) {
      var _this3 = this;

      var requestId = this._baseApis.makeTxnId();

      var requestControl = this._requests[requestId] = {
        name: name,
        devices: devices
      };
      var promise = new Promise(function (resolve, reject) {
        requestControl.resolve = resolve;
        requestControl.reject = reject;
      });

      var cancel = function cancel(reason) {
        // send cancellation event
        var cancelData = {
          action: "request_cancellation",
          requesting_device_id: _this3._baseApis.deviceId,
          request_id: requestId
        };
        var toDevice = {};

        var _iterator2 = _createForOfIteratorHelper(devices),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var device = _step2.value;
            toDevice[device] = cancelData;
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }

        _this3._baseApis.sendToDevice("m.secret.request", (0, _defineProperty2["default"])({}, _this3._baseApis.getUserId(), toDevice)); // and reject the promise so that anyone waiting on it will be
        // notified


        requestControl.reject(new Error(reason || "Cancelled"));
      }; // send request to devices


      var requestData = {
        name: name,
        action: "request",
        requesting_device_id: this._baseApis.deviceId,
        request_id: requestId
      };
      var toDevice = {};

      var _iterator3 = _createForOfIteratorHelper(devices),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var device = _step3.value;
          toDevice[device] = requestData;
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      _logger.logger.info("Request secret ".concat(name, " from ").concat(devices, ", id ").concat(requestId));

      this._baseApis.sendToDevice("m.secret.request", (0, _defineProperty2["default"])({}, this._baseApis.getUserId(), toDevice));

      return {
        request_id: requestId,
        promise: promise,
        cancel: cancel
      };
    }
  }, {
    key: "_onRequestReceived",
    value: function () {
      var _onRequestReceived2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(event) {
        var sender, content, deviceId, secret, payload, encryptedContent, contentMap;
        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                sender = event.getSender();
                content = event.getContent();

                if (!(sender !== this._baseApis.getUserId() || !(content.name && content.action && content.requesting_device_id && content.request_id))) {
                  _context11.next = 4;
                  break;
                }

                return _context11.abrupt("return");

              case 4:
                deviceId = content.requesting_device_id; // check if it's a cancel

                if (!(content.action === "request_cancellation")) {
                  _context11.next = 9;
                  break;
                }

                if (this._incomingRequests[deviceId] && this._incomingRequests[deviceId][content.request_id]) {
                  _logger.logger.info("received request cancellation for secret (" + sender + ", " + deviceId + ", " + content.request_id + ")");

                  this.baseApis.emit("crypto.secrets.requestCancelled", {
                    user_id: sender,
                    device_id: deviceId,
                    request_id: content.request_id
                  });
                }

                _context11.next = 32;
                break;

              case 9:
                if (!(content.action === "request")) {
                  _context11.next = 32;
                  break;
                }

                if (!(deviceId === this._baseApis.deviceId)) {
                  _context11.next = 12;
                  break;
                }

                return _context11.abrupt("return");

              case 12:
                // check if we have the secret
                _logger.logger.info("received request for secret (" + sender + ", " + deviceId + ", " + content.request_id + ")");

                if (this._cryptoCallbacks.onSecretRequested) {
                  _context11.next = 15;
                  break;
                }

                return _context11.abrupt("return");

              case 15:
                _context11.next = 17;
                return this._cryptoCallbacks.onSecretRequested(sender, deviceId, content.request_id, content.name, this._baseApis.checkDeviceTrust(sender, deviceId));

              case 17:
                secret = _context11.sent;

                if (!secret) {
                  _context11.next = 31;
                  break;
                }

                _logger.logger.info("Preparing ".concat(content.name, " secret for ").concat(deviceId));

                payload = {
                  type: "m.secret.send",
                  content: {
                    request_id: content.request_id,
                    secret: secret
                  }
                };
                encryptedContent = {
                  algorithm: olmlib.OLM_ALGORITHM,
                  sender_key: this._baseApis._crypto._olmDevice.deviceCurve25519Key,
                  ciphertext: {}
                };
                _context11.next = 24;
                return olmlib.ensureOlmSessionsForDevices(this._baseApis._crypto._olmDevice, this._baseApis, (0, _defineProperty2["default"])({}, sender, [this._baseApis.getStoredDevice(sender, deviceId)]));

              case 24:
                _context11.next = 26;
                return olmlib.encryptMessageForDevice(encryptedContent.ciphertext, this._baseApis.getUserId(), this._baseApis.deviceId, this._baseApis._crypto._olmDevice, sender, this._baseApis.getStoredDevice(sender, deviceId), payload);

              case 26:
                contentMap = (0, _defineProperty2["default"])({}, sender, (0, _defineProperty2["default"])({}, deviceId, encryptedContent));

                _logger.logger.info("Sending ".concat(content.name, " secret for ").concat(deviceId));

                this._baseApis.sendToDevice("m.room.encrypted", contentMap);

                _context11.next = 32;
                break;

              case 31:
                _logger.logger.info("Request denied for ".concat(content.name, " secret for ").concat(deviceId));

              case 32:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function _onRequestReceived(_x18) {
        return _onRequestReceived2.apply(this, arguments);
      }

      return _onRequestReceived;
    }()
  }, {
    key: "_onSecretReceived",
    value: function _onSecretReceived(event) {
      if (event.getSender() !== this._baseApis.getUserId()) {
        // we shouldn't be receiving secrets from anyone else, so ignore
        // because someone could be trying to send us bogus data
        return;
      }

      var content = event.getContent();

      _logger.logger.log("got secret share for request", content.request_id);

      var requestControl = this._requests[content.request_id];

      if (requestControl) {
        // make sure that the device that sent it is one of the devices that
        // we requested from
        var deviceInfo = this._baseApis._crypto._deviceList.getDeviceByIdentityKey(olmlib.OLM_ALGORITHM, event.getSenderKey());

        if (!deviceInfo) {
          _logger.logger.log("secret share from unknown device with key", event.getSenderKey());

          return;
        }

        if (!requestControl.devices.includes(deviceInfo.deviceId)) {
          _logger.logger.log("unsolicited secret share from device", deviceInfo.deviceId);

          return;
        }

        _logger.logger.log("Successfully received secret ".concat(requestControl.name, " ") + "from ".concat(deviceInfo.deviceId));

        requestControl.resolve(content.secret);
      }
    }
  }, {
    key: "_getSecretStorageKey",
    value: function () {
      var _getSecretStorageKey2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14(keys, name) {
        var returned, _returned, keyId, privateKey, decryption;

        return _regenerator["default"].wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                if (this._cryptoCallbacks.getSecretStorageKey) {
                  _context14.next = 2;
                  break;
                }

                throw new Error("No getSecretStorageKey callback supplied");

              case 2:
                _context14.next = 4;
                return this._cryptoCallbacks.getSecretStorageKey({
                  keys: keys
                }, name);

              case 4:
                returned = _context14.sent;

                if (returned) {
                  _context14.next = 7;
                  break;
                }

                throw new Error("getSecretStorageKey callback returned falsey");

              case 7:
                if (!(returned.length < 2)) {
                  _context14.next = 9;
                  break;
                }

                throw new Error("getSecretStorageKey callback returned invalid data");

              case 9:
                _returned = (0, _slicedToArray2["default"])(returned, 2), keyId = _returned[0], privateKey = _returned[1];

                if (keys[keyId]) {
                  _context14.next = 12;
                  break;
                }

                throw new Error("App returned unknown key from getSecretStorageKey!");

              case 12:
                if (!(keys[keyId].algorithm === SECRET_STORAGE_ALGORITHM_V1_AES)) {
                  _context14.next = 17;
                  break;
                }

                decryption = {
                  encrypt: function () {
                    var _encrypt = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(secret) {
                      return _regenerator["default"].wrap(function _callee12$(_context12) {
                        while (1) {
                          switch (_context12.prev = _context12.next) {
                            case 0:
                              _context12.next = 2;
                              return (0, _aes.encryptAES)(secret, privateKey, name);

                            case 2:
                              return _context12.abrupt("return", _context12.sent);

                            case 3:
                            case "end":
                              return _context12.stop();
                          }
                        }
                      }, _callee12);
                    }));

                    function encrypt(_x21) {
                      return _encrypt.apply(this, arguments);
                    }

                    return encrypt;
                  }(),
                  decrypt: function () {
                    var _decrypt = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13(encInfo) {
                      return _regenerator["default"].wrap(function _callee13$(_context13) {
                        while (1) {
                          switch (_context13.prev = _context13.next) {
                            case 0:
                              _context13.next = 2;
                              return (0, _aes.decryptAES)(encInfo, privateKey, name);

                            case 2:
                              return _context13.abrupt("return", _context13.sent);

                            case 3:
                            case "end":
                              return _context13.stop();
                          }
                        }
                      }, _callee13);
                    }));

                    function decrypt(_x22) {
                      return _decrypt.apply(this, arguments);
                    }

                    return decrypt;
                  }()
                };
                return _context14.abrupt("return", [keyId, decryption]);

              case 17:
                throw new Error("Unknown key type: " + keys[keyId].algorithm);

              case 18:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function _getSecretStorageKey(_x19, _x20) {
        return _getSecretStorageKey2.apply(this, arguments);
      }

      return _getSecretStorageKey;
    }()
  }], [{
    key: "_calculateKeyCheck",
    value: function () {
      var _calculateKeyCheck2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(key, iv) {
        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return (0, _aes.encryptAES)(ZERO_STR, key, "", iv);

              case 2:
                return _context15.abrupt("return", _context15.sent);

              case 3:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15);
      }));

      function _calculateKeyCheck(_x23, _x24) {
        return _calculateKeyCheck2.apply(this, arguments);
      }

      return _calculateKeyCheck;
    }()
  }]);
  return SecretStorage;
}(_events.EventEmitter);

exports.SecretStorage = SecretStorage;