"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LocalStorageCryptoStore = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _logger = require("../../logger");

var _memoryCryptoStore = require("./memory-crypto-store");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * Internal module. Partial localStorage backed storage for e2e.
 * This is not a full crypto store, just the in-memory store with
 * some things backed by localStorage. It exists because indexedDB
 * is broken in Firefox private mode or set to, "will not remember
 * history".
 *
 * @module
 */
var E2E_PREFIX = "crypto.";
var KEY_END_TO_END_ACCOUNT = E2E_PREFIX + "account";
var KEY_CROSS_SIGNING_KEYS = E2E_PREFIX + "cross_signing_keys";
var KEY_NOTIFIED_ERROR_DEVICES = E2E_PREFIX + "notified_error_devices";
var KEY_DEVICE_DATA = E2E_PREFIX + "device_data";
var KEY_INBOUND_SESSION_PREFIX = E2E_PREFIX + "inboundgroupsessions/";
var KEY_INBOUND_SESSION_WITHHELD_PREFIX = E2E_PREFIX + "inboundgroupsessions.withheld/";
var KEY_ROOMS_PREFIX = E2E_PREFIX + "rooms/";
var KEY_SESSIONS_NEEDING_BACKUP = E2E_PREFIX + "sessionsneedingbackup";

function keyEndToEndSessions(deviceKey) {
  return E2E_PREFIX + "sessions/" + deviceKey;
}

function keyEndToEndSessionProblems(deviceKey) {
  return E2E_PREFIX + "session.problems/" + deviceKey;
}

function keyEndToEndInboundGroupSession(senderKey, sessionId) {
  return KEY_INBOUND_SESSION_PREFIX + senderKey + "/" + sessionId;
}

function keyEndToEndInboundGroupSessionWithheld(senderKey, sessionId) {
  return KEY_INBOUND_SESSION_WITHHELD_PREFIX + senderKey + "/" + sessionId;
}

function keyEndToEndRoomsPrefix(roomId) {
  return KEY_ROOMS_PREFIX + roomId;
}
/**
 * @implements {module:crypto/store/base~CryptoStore}
 */


var LocalStorageCryptoStore = /*#__PURE__*/function (_MemoryCryptoStore) {
  (0, _inherits2["default"])(LocalStorageCryptoStore, _MemoryCryptoStore);

  var _super = _createSuper(LocalStorageCryptoStore);

  function LocalStorageCryptoStore(webStore) {
    var _this;

    (0, _classCallCheck2["default"])(this, LocalStorageCryptoStore);
    _this = _super.call(this);
    _this.store = webStore;
    return _this;
  }

  (0, _createClass2["default"])(LocalStorageCryptoStore, [{
    key: "countEndToEndSessions",
    // Olm Sessions
    value: function countEndToEndSessions(txn, func) {
      var count = 0;

      for (var i = 0; i < this.store.length; ++i) {
        if (this.store.key(i).startsWith(keyEndToEndSessions(''))) ++count;
      }

      func(count);
    }
  }, {
    key: "_getEndToEndSessions",
    value: function _getEndToEndSessions(deviceKey, txn, func) {
      var sessions = getJsonItem(this.store, keyEndToEndSessions(deviceKey));
      var fixedSessions = {}; // fix up any old sessions to be objects rather than just the base64 pickle

      for (var _i = 0, _Object$entries = Object.entries(sessions || {}); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = (0, _slicedToArray2["default"])(_Object$entries[_i], 2),
            sid = _Object$entries$_i[0],
            val = _Object$entries$_i[1];

        if (typeof val === 'string') {
          fixedSessions[sid] = {
            session: val
          };
        } else {
          fixedSessions[sid] = val;
        }
      }

      return fixedSessions;
    }
  }, {
    key: "getEndToEndSession",
    value: function getEndToEndSession(deviceKey, sessionId, txn, func) {
      var sessions = this._getEndToEndSessions(deviceKey);

      func(sessions[sessionId] || {});
    }
  }, {
    key: "getEndToEndSessions",
    value: function getEndToEndSessions(deviceKey, txn, func) {
      func(this._getEndToEndSessions(deviceKey) || {});
    }
  }, {
    key: "getAllEndToEndSessions",
    value: function getAllEndToEndSessions(txn, func) {
      for (var i = 0; i < this.store.length; ++i) {
        if (this.store.key(i).startsWith(keyEndToEndSessions(''))) {
          var deviceKey = this.store.key(i).split('/')[1];

          for (var _i2 = 0, _Object$values = Object.values(this._getEndToEndSessions(deviceKey)); _i2 < _Object$values.length; _i2++) {
            var sess = _Object$values[_i2];
            func(sess);
          }
        }
      }
    }
  }, {
    key: "storeEndToEndSession",
    value: function storeEndToEndSession(deviceKey, sessionId, sessionInfo, txn) {
      var sessions = this._getEndToEndSessions(deviceKey) || {};
      sessions[sessionId] = sessionInfo;
      setJsonItem(this.store, keyEndToEndSessions(deviceKey), sessions);
    }
  }, {
    key: "storeEndToEndSessionProblem",
    value: function () {
      var _storeEndToEndSessionProblem = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(deviceKey, type, fixed) {
        var key, problems;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                key = keyEndToEndSessionProblems(deviceKey);
                problems = getJsonItem(this.store, key) || [];
                problems.push({
                  type: type,
                  fixed: fixed,
                  time: Date.now()
                });
                problems.sort(function (a, b) {
                  return a.time - b.time;
                });
                setJsonItem(this.store, key, problems);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function storeEndToEndSessionProblem(_x, _x2, _x3) {
        return _storeEndToEndSessionProblem.apply(this, arguments);
      }

      return storeEndToEndSessionProblem;
    }()
  }, {
    key: "getEndToEndSessionProblem",
    value: function () {
      var _getEndToEndSessionProblem = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(deviceKey, timestamp) {
        var key, problems, lastProblem, _iterator, _step, problem;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                key = keyEndToEndSessionProblems(deviceKey);
                problems = getJsonItem(this.store, key) || [];

                if (problems.length) {
                  _context2.next = 4;
                  break;
                }

                return _context2.abrupt("return", null);

              case 4:
                lastProblem = problems[problems.length - 1];
                _iterator = _createForOfIteratorHelper(problems);
                _context2.prev = 6;

                _iterator.s();

              case 8:
                if ((_step = _iterator.n()).done) {
                  _context2.next = 14;
                  break;
                }

                problem = _step.value;

                if (!(problem.time > timestamp)) {
                  _context2.next = 12;
                  break;
                }

                return _context2.abrupt("return", Object.assign({}, problem, {
                  fixed: lastProblem.fixed
                }));

              case 12:
                _context2.next = 8;
                break;

              case 14:
                _context2.next = 19;
                break;

              case 16:
                _context2.prev = 16;
                _context2.t0 = _context2["catch"](6);

                _iterator.e(_context2.t0);

              case 19:
                _context2.prev = 19;

                _iterator.f();

                return _context2.finish(19);

              case 22:
                if (!lastProblem.fixed) {
                  _context2.next = 26;
                  break;
                }

                return _context2.abrupt("return", null);

              case 26:
                return _context2.abrupt("return", lastProblem);

              case 27:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[6, 16, 19, 22]]);
      }));

      function getEndToEndSessionProblem(_x4, _x5) {
        return _getEndToEndSessionProblem.apply(this, arguments);
      }

      return getEndToEndSessionProblem;
    }()
  }, {
    key: "filterOutNotifiedErrorDevices",
    value: function () {
      var _filterOutNotifiedErrorDevices = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(devices) {
        var notifiedErrorDevices, ret, _iterator2, _step2, device, userId, deviceInfo;

        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                notifiedErrorDevices = getJsonItem(this.store, KEY_NOTIFIED_ERROR_DEVICES) || {};
                ret = [];
                _iterator2 = _createForOfIteratorHelper(devices);

                try {
                  for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                    device = _step2.value;
                    userId = device.userId, deviceInfo = device.deviceInfo;

                    if (userId in notifiedErrorDevices) {
                      if (!(deviceInfo.deviceId in notifiedErrorDevices[userId])) {
                        ret.push(device);
                        notifiedErrorDevices[userId][deviceInfo.deviceId] = true;
                      }
                    } else {
                      ret.push(device);
                      notifiedErrorDevices[userId] = (0, _defineProperty2["default"])({}, deviceInfo.deviceId, true);
                    }
                  }
                } catch (err) {
                  _iterator2.e(err);
                } finally {
                  _iterator2.f();
                }

                setJsonItem(this.store, KEY_NOTIFIED_ERROR_DEVICES, notifiedErrorDevices);
                return _context3.abrupt("return", ret);

              case 6:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function filterOutNotifiedErrorDevices(_x6) {
        return _filterOutNotifiedErrorDevices.apply(this, arguments);
      }

      return filterOutNotifiedErrorDevices;
    }() // Inbound Group Sessions

  }, {
    key: "getEndToEndInboundGroupSession",
    value: function getEndToEndInboundGroupSession(senderCurve25519Key, sessionId, txn, func) {
      func(getJsonItem(this.store, keyEndToEndInboundGroupSession(senderCurve25519Key, sessionId)), getJsonItem(this.store, keyEndToEndInboundGroupSessionWithheld(senderCurve25519Key, sessionId)));
    }
  }, {
    key: "getAllEndToEndInboundGroupSessions",
    value: function getAllEndToEndInboundGroupSessions(txn, func) {
      for (var i = 0; i < this.store.length; ++i) {
        var key = this.store.key(i);

        if (key.startsWith(KEY_INBOUND_SESSION_PREFIX)) {
          // we can't use split, as the components we are trying to split out
          // might themselves contain '/' characters. We rely on the
          // senderKey being a (32-byte) curve25519 key, base64-encoded
          // (hence 43 characters long).
          func({
            senderKey: key.substr(KEY_INBOUND_SESSION_PREFIX.length, 43),
            sessionId: key.substr(KEY_INBOUND_SESSION_PREFIX.length + 44),
            sessionData: getJsonItem(this.store, key)
          });
        }
      }

      func(null);
    }
  }, {
    key: "addEndToEndInboundGroupSession",
    value: function addEndToEndInboundGroupSession(senderCurve25519Key, sessionId, sessionData, txn) {
      var existing = getJsonItem(this.store, keyEndToEndInboundGroupSession(senderCurve25519Key, sessionId));

      if (!existing) {
        this.storeEndToEndInboundGroupSession(senderCurve25519Key, sessionId, sessionData, txn);
      }
    }
  }, {
    key: "storeEndToEndInboundGroupSession",
    value: function storeEndToEndInboundGroupSession(senderCurve25519Key, sessionId, sessionData, txn) {
      setJsonItem(this.store, keyEndToEndInboundGroupSession(senderCurve25519Key, sessionId), sessionData);
    }
  }, {
    key: "storeEndToEndInboundGroupSessionWithheld",
    value: function storeEndToEndInboundGroupSessionWithheld(senderCurve25519Key, sessionId, sessionData, txn) {
      setJsonItem(this.store, keyEndToEndInboundGroupSessionWithheld(senderCurve25519Key, sessionId), sessionData);
    }
  }, {
    key: "getEndToEndDeviceData",
    value: function getEndToEndDeviceData(txn, func) {
      func(getJsonItem(this.store, KEY_DEVICE_DATA));
    }
  }, {
    key: "storeEndToEndDeviceData",
    value: function storeEndToEndDeviceData(deviceData, txn) {
      setJsonItem(this.store, KEY_DEVICE_DATA, deviceData);
    }
  }, {
    key: "storeEndToEndRoom",
    value: function storeEndToEndRoom(roomId, roomInfo, txn) {
      setJsonItem(this.store, keyEndToEndRoomsPrefix(roomId), roomInfo);
    }
  }, {
    key: "getEndToEndRooms",
    value: function getEndToEndRooms(txn, func) {
      var result = {};
      var prefix = keyEndToEndRoomsPrefix('');

      for (var i = 0; i < this.store.length; ++i) {
        var key = this.store.key(i);

        if (key.startsWith(prefix)) {
          var roomId = key.substr(prefix.length);
          result[roomId] = getJsonItem(this.store, key);
        }
      }

      func(result);
    }
  }, {
    key: "getSessionsNeedingBackup",
    value: function getSessionsNeedingBackup(limit) {
      var _this2 = this;

      var sessionsNeedingBackup = getJsonItem(this.store, KEY_SESSIONS_NEEDING_BACKUP) || {};
      var sessions = [];

      for (var session in sessionsNeedingBackup) {
        if (Object.prototype.hasOwnProperty.call(sessionsNeedingBackup, session)) {
          var _ret = function () {
            // see getAllEndToEndInboundGroupSessions for the magic number explanations
            var senderKey = session.substr(0, 43);
            var sessionId = session.substr(44);

            _this2.getEndToEndInboundGroupSession(senderKey, sessionId, null, function (sessionData) {
              sessions.push({
                senderKey: senderKey,
                sessionId: sessionId,
                sessionData: sessionData
              });
            });

            if (limit && session.length >= limit) {
              return "break";
            }
          }();

          if (_ret === "break") break;
        }
      }

      return Promise.resolve(sessions);
    }
  }, {
    key: "countSessionsNeedingBackup",
    value: function countSessionsNeedingBackup() {
      var sessionsNeedingBackup = getJsonItem(this.store, KEY_SESSIONS_NEEDING_BACKUP) || {};
      return Promise.resolve(Object.keys(sessionsNeedingBackup).length);
    }
  }, {
    key: "unmarkSessionsNeedingBackup",
    value: function unmarkSessionsNeedingBackup(sessions) {
      var sessionsNeedingBackup = getJsonItem(this.store, KEY_SESSIONS_NEEDING_BACKUP) || {};

      var _iterator3 = _createForOfIteratorHelper(sessions),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var session = _step3.value;
          delete sessionsNeedingBackup[session.senderKey + '/' + session.sessionId];
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      setJsonItem(this.store, KEY_SESSIONS_NEEDING_BACKUP, sessionsNeedingBackup);
      return Promise.resolve();
    }
  }, {
    key: "markSessionsNeedingBackup",
    value: function markSessionsNeedingBackup(sessions) {
      var sessionsNeedingBackup = getJsonItem(this.store, KEY_SESSIONS_NEEDING_BACKUP) || {};

      var _iterator4 = _createForOfIteratorHelper(sessions),
          _step4;

      try {
        for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
          var session = _step4.value;
          sessionsNeedingBackup[session.senderKey + '/' + session.sessionId] = true;
        }
      } catch (err) {
        _iterator4.e(err);
      } finally {
        _iterator4.f();
      }

      setJsonItem(this.store, KEY_SESSIONS_NEEDING_BACKUP, sessionsNeedingBackup);
      return Promise.resolve();
    }
    /**
     * Delete all data from this store.
     *
     * @returns {Promise} Promise which resolves when the store has been cleared.
     */

  }, {
    key: "deleteAllData",
    value: function deleteAllData() {
      this.store.removeItem(KEY_END_TO_END_ACCOUNT);
      return Promise.resolve();
    } // Olm account

  }, {
    key: "getAccount",
    value: function getAccount(txn, func) {
      var account = getJsonItem(this.store, KEY_END_TO_END_ACCOUNT);
      func(account);
    }
  }, {
    key: "storeAccount",
    value: function storeAccount(txn, newData) {
      setJsonItem(this.store, KEY_END_TO_END_ACCOUNT, newData);
    }
  }, {
    key: "getCrossSigningKeys",
    value: function getCrossSigningKeys(txn, func) {
      var keys = getJsonItem(this.store, KEY_CROSS_SIGNING_KEYS);
      func(keys);
    }
  }, {
    key: "getSecretStorePrivateKey",
    value: function getSecretStorePrivateKey(txn, func, type) {
      var key = getJsonItem(this.store, E2E_PREFIX + "ssss_cache.".concat(type));
      func(key);
    }
  }, {
    key: "storeCrossSigningKeys",
    value: function storeCrossSigningKeys(txn, keys) {
      setJsonItem(this.store, KEY_CROSS_SIGNING_KEYS, keys);
    }
  }, {
    key: "storeSecretStorePrivateKey",
    value: function storeSecretStorePrivateKey(txn, type, key) {
      setJsonItem(this.store, E2E_PREFIX + "ssss_cache.".concat(type), key);
    }
  }, {
    key: "doTxn",
    value: function doTxn(mode, stores, func) {
      return Promise.resolve(func(null));
    }
  }], [{
    key: "exists",
    value: function exists(webStore) {
      var length = webStore.length;

      for (var i = 0; i < length; i++) {
        if (webStore.key(i).startsWith(E2E_PREFIX)) {
          return true;
        }
      }

      return false;
    }
  }]);
  return LocalStorageCryptoStore;
}(_memoryCryptoStore.MemoryCryptoStore);

exports.LocalStorageCryptoStore = LocalStorageCryptoStore;

function getJsonItem(store, key) {
  try {
    // if the key is absent, store.getItem() returns null, and
    // JSON.parse(null) === null, so this returns null.
    return JSON.parse(store.getItem(key));
  } catch (e) {
    _logger.logger.log("Error: Failed to get key %s: %s", key, e.stack || e);

    _logger.logger.log(e.stack);
  }

  return null;
}

function setJsonItem(store, key, val) {
  store.setItem(key, JSON.stringify(val));
}