"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QRCodeData = exports.ReciprocateQRCode = exports.SCAN_QR_CODE_METHOD = exports.SHOW_QR_CODE_METHOD = void 0;

var _construct2 = _interopRequireDefault(require("@babel/runtime/helpers/construct"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _Base2 = require("./Base");

var _Error = require("./Error");

var _olmlib = require("../olmlib");

var _logger = require("../../logger");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var SHOW_QR_CODE_METHOD = "m.qr_code.show.v1";
exports.SHOW_QR_CODE_METHOD = SHOW_QR_CODE_METHOD;
var SCAN_QR_CODE_METHOD = "m.qr_code.scan.v1";
/**
 * @class crypto/verification/QRCode/ReciprocateQRCode
 * @extends {module:crypto/verification/Base}
 */

exports.SCAN_QR_CODE_METHOD = SCAN_QR_CODE_METHOD;

var ReciprocateQRCode = /*#__PURE__*/function (_Base) {
  (0, _inherits2["default"])(ReciprocateQRCode, _Base);

  var _super = _createSuper(ReciprocateQRCode);

  function ReciprocateQRCode() {
    (0, _classCallCheck2["default"])(this, ReciprocateQRCode);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(ReciprocateQRCode, [{
    key: "_doVerification",
    value: function () {
      var _doVerification2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var _this = this;

        var qrCodeData, keys, masterKey, deviceId, _masterKey;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this.startEvent) {
                  _context.next = 2;
                  break;
                }

                throw new Error("It is not currently possible to start verification" + "with this method yet.");

              case 2:
                qrCodeData = this.request.qrCodeData; // 1. check the secret

                if (!(this.startEvent.getContent()['secret'] !== qrCodeData.encodedSharedSecret)) {
                  _context.next = 5;
                  break;
                }

                throw (0, _Error.newKeyMismatchError)();

              case 5:
                _context.next = 7;
                return new Promise(function (resolve, reject) {
                  _this.reciprocateQREvent = {
                    confirm: resolve,
                    cancel: function cancel() {
                      return reject((0, _Error.newUserCancelledError)());
                    }
                  };

                  _this.emit("show_reciprocate_qr", _this.reciprocateQREvent);
                });

              case 7:
                // 3. determine key to sign / mark as trusted
                keys = {};
                _context.t0 = qrCodeData.mode;
                _context.next = _context.t0 === MODE_VERIFY_OTHER_USER ? 11 : _context.t0 === MODE_VERIFY_SELF_TRUSTED ? 14 : _context.t0 === MODE_VERIFY_SELF_UNTRUSTED ? 17 : 20;
                break;

              case 11:
                // add master key to keys to be signed, only if we're not doing self-verification
                masterKey = qrCodeData.otherUserMasterKey;
                keys["ed25519:".concat(masterKey)] = masterKey;
                return _context.abrupt("break", 20);

              case 14:
                deviceId = this.request.targetDevice.deviceId;
                keys["ed25519:".concat(deviceId)] = qrCodeData.otherDeviceKey;
                return _context.abrupt("break", 20);

              case 17:
                _masterKey = qrCodeData.myMasterKey;
                keys["ed25519:".concat(_masterKey)] = _masterKey;
                return _context.abrupt("break", 20);

              case 20:
                _context.next = 22;
                return this._verifyKeys(this.userId, keys, function (keyId, device, keyInfo) {
                  // make sure the device has the expected keys
                  var targetKey = keys[keyId];
                  if (!targetKey) throw (0, _Error.newKeyMismatchError)();

                  if (keyInfo !== targetKey) {
                    _logger.logger.error("key ID from key info does not match");

                    throw (0, _Error.newKeyMismatchError)();
                  }

                  for (var deviceKeyId in device.keys) {
                    if (!deviceKeyId.startsWith("ed25519")) continue;
                    var deviceTargetKey = keys[deviceKeyId];
                    if (!deviceTargetKey) throw (0, _Error.newKeyMismatchError)();

                    if (device.keys[deviceKeyId] !== deviceTargetKey) {
                      _logger.logger.error("master key does not match");

                      throw (0, _Error.newKeyMismatchError)();
                    }
                  }
                });

              case 22:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _doVerification() {
        return _doVerification2.apply(this, arguments);
      }

      return _doVerification;
    }()
  }], [{
    key: "factory",
    value: function factory() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return (0, _construct2["default"])(ReciprocateQRCode, args);
    }
  }, {
    key: "NAME",
    get: function get() {
      return "m.reciprocate.v1";
    }
  }]);
  return ReciprocateQRCode;
}(_Base2.VerificationBase);

exports.ReciprocateQRCode = ReciprocateQRCode;
var CODE_VERSION = 0x02; // the version of binary QR codes we support

var BINARY_PREFIX = "MATRIX"; // ASCII, used to prefix the binary format

var MODE_VERIFY_OTHER_USER = 0x00; // Verifying someone who isn't us

var MODE_VERIFY_SELF_TRUSTED = 0x01; // We trust the master key

var MODE_VERIFY_SELF_UNTRUSTED = 0x02; // We do not trust the master key

var QRCodeData = /*#__PURE__*/function () {
  function QRCodeData(mode, sharedSecret, otherUserMasterKey, otherDeviceKey, myMasterKey, buffer) {
    (0, _classCallCheck2["default"])(this, QRCodeData);
    this._sharedSecret = sharedSecret;
    this._mode = mode;
    this._otherUserMasterKey = otherUserMasterKey;
    this._otherDeviceKey = otherDeviceKey;
    this._myMasterKey = myMasterKey;
    this._buffer = buffer;
  }

  (0, _createClass2["default"])(QRCodeData, [{
    key: "buffer",
    get: function get() {
      return this._buffer;
    }
  }, {
    key: "mode",
    get: function get() {
      return this._mode;
    }
    /**
     * only set when mode is MODE_VERIFY_SELF_TRUSTED
     * @return {string} device key of other party at time of generating QR code
     */

  }, {
    key: "otherDeviceKey",
    get: function get() {
      return this._otherDeviceKey;
    }
    /**
     * only set when mode is MODE_VERIFY_OTHER_USER
     * @return {string} master key of other party at time of generating QR code
     */

  }, {
    key: "otherUserMasterKey",
    get: function get() {
      return this._otherUserMasterKey;
    }
    /**
     * only set when mode is MODE_VERIFY_SELF_UNTRUSTED
     * @return {string} own master key at time of generating QR code
     */

  }, {
    key: "myMasterKey",
    get: function get() {
      return this._myMasterKey;
    }
    /**
     * The unpadded base64 encoded shared secret.
     */

  }, {
    key: "encodedSharedSecret",
    get: function get() {
      return this._sharedSecret;
    }
  }], [{
    key: "create",
    value: function () {
      var _create = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(request, client) {
        var sharedSecret, mode, otherUserMasterKey, otherDeviceKey, myMasterKey, otherUserCrossSigningInfo, myUserId, myCrossSigningInfo, qrData, buffer;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                sharedSecret = QRCodeData._generateSharedSecret();
                mode = QRCodeData._determineMode(request, client);
                otherUserMasterKey = null;
                otherDeviceKey = null;
                myMasterKey = null;

                if (!(mode === MODE_VERIFY_OTHER_USER)) {
                  _context2.next = 10;
                  break;
                }

                otherUserCrossSigningInfo = client.getStoredCrossSigningForUser(request.otherUserId);
                otherUserMasterKey = otherUserCrossSigningInfo.getId("master");
                _context2.next = 17;
                break;

              case 10:
                if (!(mode === MODE_VERIFY_SELF_TRUSTED)) {
                  _context2.next = 16;
                  break;
                }

                _context2.next = 13;
                return QRCodeData._getOtherDeviceKey(request, client);

              case 13:
                otherDeviceKey = _context2.sent;
                _context2.next = 17;
                break;

              case 16:
                if (mode === MODE_VERIFY_SELF_UNTRUSTED) {
                  myUserId = client.getUserId();
                  myCrossSigningInfo = client.getStoredCrossSigningForUser(myUserId);
                  myMasterKey = myCrossSigningInfo.getId("master");
                }

              case 17:
                qrData = QRCodeData._generateQrData(request, client, mode, sharedSecret, otherUserMasterKey, otherDeviceKey, myMasterKey);
                buffer = QRCodeData._generateBuffer(qrData);
                return _context2.abrupt("return", new QRCodeData(mode, sharedSecret, otherUserMasterKey, otherDeviceKey, myMasterKey, buffer));

              case 20:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function create(_x, _x2) {
        return _create.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: "_generateSharedSecret",
    value: function _generateSharedSecret() {
      var secretBytes = new Uint8Array(11);
      global.crypto.getRandomValues(secretBytes);
      return (0, _olmlib.encodeUnpaddedBase64)(secretBytes);
    }
  }, {
    key: "_getOtherDeviceKey",
    value: function () {
      var _getOtherDeviceKey2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(request, client) {
        var myUserId, otherDevice, otherDeviceId, device, key;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                myUserId = client.getUserId();
                otherDevice = request.targetDevice;
                otherDeviceId = otherDevice ? otherDevice.deviceId : null;
                device = client.getStoredDevice(myUserId, otherDeviceId);

                if (device) {
                  _context3.next = 6;
                  break;
                }

                throw new Error("could not find device " + otherDeviceId);

              case 6:
                key = device.getFingerprint();
                return _context3.abrupt("return", key);

              case 8:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function _getOtherDeviceKey(_x3, _x4) {
        return _getOtherDeviceKey2.apply(this, arguments);
      }

      return _getOtherDeviceKey;
    }()
  }, {
    key: "_determineMode",
    value: function _determineMode(request, client) {
      var myUserId = client.getUserId();
      var otherUserId = request.otherUserId;
      var mode = MODE_VERIFY_OTHER_USER;

      if (myUserId === otherUserId) {
        // Mode changes depending on whether or not we trust the master cross signing key
        var myTrust = client.checkUserTrust(myUserId);

        if (myTrust.isCrossSigningVerified()) {
          mode = MODE_VERIFY_SELF_TRUSTED;
        } else {
          mode = MODE_VERIFY_SELF_UNTRUSTED;
        }
      }

      return mode;
    }
  }, {
    key: "_generateQrData",
    value: function _generateQrData(request, client, mode, encodedSharedSecret, otherUserMasterKey, otherDeviceKey, myMasterKey) {
      var myUserId = client.getUserId();
      var transactionId = request.channel.transactionId;
      var qrData = {
        prefix: BINARY_PREFIX,
        version: CODE_VERSION,
        mode: mode,
        transactionId: transactionId,
        firstKeyB64: '',
        // worked out shortly
        secondKeyB64: '',
        // worked out shortly
        secretB64: encodedSharedSecret
      };
      var myCrossSigningInfo = client.getStoredCrossSigningForUser(myUserId);

      if (mode === MODE_VERIFY_OTHER_USER) {
        // First key is our master cross signing key
        qrData.firstKeyB64 = myCrossSigningInfo.getId("master"); // Second key is the other user's master cross signing key

        qrData.secondKeyB64 = otherUserMasterKey;
      } else if (mode === MODE_VERIFY_SELF_TRUSTED) {
        // First key is our master cross signing key
        qrData.firstKeyB64 = myCrossSigningInfo.getId("master");
        qrData.secondKeyB64 = otherDeviceKey;
      } else if (mode === MODE_VERIFY_SELF_UNTRUSTED) {
        // First key is our device's key
        qrData.firstKeyB64 = client.getDeviceEd25519Key(); // Second key is what we think our master cross signing key is

        qrData.secondKeyB64 = myMasterKey;
      }

      return qrData;
    }
  }, {
    key: "_generateBuffer",
    value: function _generateBuffer(qrData) {
      var buf = Buffer.alloc(0); // we'll concat our way through life

      var appendByte = function appendByte(b) {
        var tmpBuf = Buffer.from([b]);
        buf = Buffer.concat([buf, tmpBuf]);
      };

      var appendInt = function appendInt(i) {
        var tmpBuf = Buffer.alloc(2);
        tmpBuf.writeInt16BE(i, 0);
        buf = Buffer.concat([buf, tmpBuf]);
      };

      var appendStr = function appendStr(s, enc) {
        var withLengthPrefix = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var tmpBuf = Buffer.from(s, enc);
        if (withLengthPrefix) appendInt(tmpBuf.byteLength);
        buf = Buffer.concat([buf, tmpBuf]);
      };

      var appendEncBase64 = function appendEncBase64(b64) {
        var b = (0, _olmlib.decodeBase64)(b64);
        var tmpBuf = Buffer.from(b);
        buf = Buffer.concat([buf, tmpBuf]);
      }; // Actually build the buffer for the QR code


      appendStr(qrData.prefix, "ascii", false);
      appendByte(qrData.version);
      appendByte(qrData.mode);
      appendStr(qrData.transactionId, "utf-8");
      appendEncBase64(qrData.firstKeyB64);
      appendEncBase64(qrData.secondKeyB64);
      appendEncBase64(qrData.secretB64);
      return buf;
    }
  }]);
  return QRCodeData;
}();

exports.QRCodeData = QRCodeData;