"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setAudioOutput = setAudioOutput;
exports.setAudioInput = setAudioInput;
exports.setVideoInput = setVideoInput;
exports.createNewMatrixCall = createNewMatrixCall;
exports.MatrixCall = exports.CallError = exports.CallErrorCode = exports.CallEvent = exports.CallParty = exports.CallDirection = exports.CallType = exports.CallState = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _logger = require("../logger");

var _events = require("events");

var utils = _interopRequireWildcard(require("../utils"));

var _event = require("../@types/event");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var CallState;
exports.CallState = CallState;

(function (CallState) {
  CallState["Fledgling"] = "fledgling";
  CallState["InviteSent"] = "invite_sent";
  CallState["WaitLocalMedia"] = "wait_local_media";
  CallState["CreateOffer"] = "create_offer";
  CallState["CreateAnswer"] = "create_answer";
  CallState["Connecting"] = "connecting";
  CallState["Connected"] = "connected";
  CallState["Ringing"] = "ringing";
  CallState["Ended"] = "ended";
})(CallState || (exports.CallState = CallState = {}));

var CallType;
exports.CallType = CallType;

(function (CallType) {
  CallType["Voice"] = "voice";
  CallType["Video"] = "video";
})(CallType || (exports.CallType = CallType = {}));

var CallDirection;
exports.CallDirection = CallDirection;

(function (CallDirection) {
  CallDirection["Inbound"] = "inbound";
  CallDirection["Outbound"] = "outbound";
})(CallDirection || (exports.CallDirection = CallDirection = {}));

var CallParty;
exports.CallParty = CallParty;

(function (CallParty) {
  CallParty["Local"] = "local";
  CallParty["Remote"] = "remote";
})(CallParty || (exports.CallParty = CallParty = {}));

var CallEvent;
exports.CallEvent = CallEvent;

(function (CallEvent) {
  CallEvent["Hangup"] = "hangup";
  CallEvent["State"] = "state";
  CallEvent["Error"] = "error";
  CallEvent["Replaced"] = "replaced";
  CallEvent["HoldUnhold"] = "hold_unhold";
})(CallEvent || (exports.CallEvent = CallEvent = {}));

var MediaQueueId;

(function (MediaQueueId) {
  MediaQueueId["RemoteVideo"] = "remote_video";
  MediaQueueId["RemoteAudio"] = "remote_audio";
  MediaQueueId["LocalVideo"] = "local_video";
})(MediaQueueId || (MediaQueueId = {}));

var CallErrorCode;
/**
 * The version field that we set in m.call.* events
 * Once we are able to speak v1 VoIP sufficiently, this
 * bumped to 1. While we partially speak v1 VoIP, it remains
 * as 0.
 */

exports.CallErrorCode = CallErrorCode;

(function (CallErrorCode) {
  CallErrorCode["UserHangup"] = "user_hangup";
  CallErrorCode["LocalOfferFailed"] = "local_offer_failed";
  CallErrorCode["NoUserMedia"] = "no_user_media";
  CallErrorCode["UnknownDevices"] = "unknown_devices";
  CallErrorCode["SendInvite"] = "send_invite";
  CallErrorCode["CreateAnswer"] = "create_answer";
  CallErrorCode["SendAnswer"] = "send_answer";
  CallErrorCode["SetRemoteDescription"] = "set_remote_description";
  CallErrorCode["SetLocalDescription"] = "set_local_description";
  CallErrorCode["AnsweredElsewhere"] = "answered_elsewhere";
  CallErrorCode["IceFailed"] = "ice_failed";
  CallErrorCode["InviteTimeout"] = "invite_timeout";
  CallErrorCode["Replaced"] = "replaced";
  CallErrorCode["SignallingFailed"] = "signalling_timeout";
})(CallErrorCode || (exports.CallErrorCode = CallErrorCode = {}));

var VOIP_PROTO_VERSION = 0;
/** The fallback ICE server to use for STUN or TURN protocols. */

var FALLBACK_ICE_SERVER = 'stun:turn.matrix.org';
/** The length of time a call can be ringing for. */

var CALL_TIMEOUT_MS = 60000;

var CallError = /*#__PURE__*/function (_Error) {
  (0, _inherits2["default"])(CallError, _Error);

  var _super = _createSuper(CallError);

  function CallError(code, msg, err) {
    var _this;

    (0, _classCallCheck2["default"])(this, CallError);
    // Stil ldon't think there's any way to have proper nested errors
    _this = _super.call(this, msg + ": " + err);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "code", void 0);
    _this.code = code;
    return _this;
  }

  return CallError;
}( /*#__PURE__*/(0, _wrapNativeSuper2["default"])(Error));
/**
 * Construct a new Matrix Call.
 * @constructor
 * @param {Object} opts Config options.
 * @param {string} opts.roomId The room ID for this call.
 * @param {Object} opts.webRtc The WebRTC globals from the browser.
 * @param {boolean} opts.forceTURN whether relay through TURN should be forced.
 * @param {Object} opts.URL The URL global.
 * @param {Array<Object>} opts.turnServers Optional. A list of TURN servers.
 * @param {MatrixClient} opts.client The Matrix Client instance to send events to.
 */


exports.CallError = CallError;

var MatrixCall = /*#__PURE__*/function (_EventEmitter) {
  (0, _inherits2["default"])(MatrixCall, _EventEmitter);

  var _super2 = _createSuper(MatrixCall);

  // Fix when client is TSified
  // XXX: This is either the invite or answer from remote...
  // XXX: I don't know why this is called 'config'.
  // The party ID of the other side: undefined if we haven't chosen a partner
  // yet, null if we have but they didn't send a party ID.
  // in the browser it's 'number'
  // The logic of when & if a call is on hold is nontrivial and explained in is*OnHold
  // This flag represents whether we want the other party to be on hold
  // Perfect negotiation state: https://www.w3.org/TR/webrtc/#perfect-negotiation-example
  function MatrixCall(opts) {
    var _this2;

    (0, _classCallCheck2["default"])(this, MatrixCall);
    _this2 = _super2.call(this);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "roomId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "type", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "callId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "state", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "hangupParty", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "hangupReason", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "direction", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "ourPartyId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "client", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "forceTURN", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "turnServers", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "candidateSendQueue", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "candidateSendTries", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "mediaPromises", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "sentEndOfCandidates", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "peerConn", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "localVideoElement", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "remoteVideoElement", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "remoteAudioElement", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "screenSharingStream", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "remoteStream", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "localAVStream", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "inviteOrAnswerSent", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "waitForLocalAVStream", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "msg", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "config", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "successor", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "opponentVersion", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "opponentPartyId", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "inviteTimeout", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "remoteOnHold", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "micMuted", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "vidMuted", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "makingOffer", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "ignoreOffer", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "gotUserMediaForInvite", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(stream) {
        var videoEl, _iterator, _step, audioTrack, _iterator2, _step2, videoTrack;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!_this2.successor) {
                  _context.next = 3;
                  break;
                }

                _this2.successor.gotUserMediaForAnswer(stream);

                return _context.abrupt("return");

              case 3:
                if (!_this2.callHasEnded()) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt("return");

              case 5:
                _this2.setState(CallState.CreateOffer);

                _logger.logger.debug("gotUserMediaForInvite -> " + _this2.type);

                videoEl = _this2.getLocalVideoElement();

                if (videoEl && _this2.type === CallType.Video) {
                  _this2.queueMediaOperation(MediaQueueId.LocalVideo, function () {
                    videoEl.autoplay = true;

                    if (_this2.screenSharingStream) {
                      _logger.logger.debug("Setting screen sharing stream to the local video element");

                      videoEl.srcObject = _this2.screenSharingStream;
                    } else {
                      videoEl.srcObject = stream;
                    }

                    videoEl.muted = true;
                    return videoEl.play();
                  });
                }

                _this2.localAVStream = stream;

                _logger.logger.info("Got local AV stream with id " + _this2.localAVStream.id); // why do we enable audio (and only audio) tracks here? -- matthew


                setTracksEnabled(stream.getAudioTracks(), true);
                _this2.peerConn = _this2.createPeerConnection();
                _iterator = _createForOfIteratorHelper(stream.getAudioTracks());

                try {
                  for (_iterator.s(); !(_step = _iterator.n()).done;) {
                    audioTrack = _step.value;

                    _logger.logger.info("Adding audio track with id " + audioTrack.id);

                    _this2.peerConn.addTrack(audioTrack, stream);
                  }
                } catch (err) {
                  _iterator.e(err);
                } finally {
                  _iterator.f();
                }

                _iterator2 = _createForOfIteratorHelper((_this2.screenSharingStream || stream).getVideoTracks());

                try {
                  for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                    videoTrack = _step2.value;

                    _logger.logger.info("Adding audio track with id " + videoTrack.id);

                    _this2.peerConn.addTrack(videoTrack, stream);
                  } // Now we wait for the negotiationneeded event

                } catch (err) {
                  _iterator2.e(err);
                } finally {
                  _iterator2.f();
                }

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "gotUserMediaForAnswer", /*#__PURE__*/function () {
      var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(stream) {
        var localVidEl, _iterator3, _step3, track, myAnswer;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!_this2.callHasEnded()) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt("return");

              case 2:
                localVidEl = _this2.getLocalVideoElement();

                if (localVidEl && _this2.type === CallType.Video) {
                  _this2.queueMediaOperation(MediaQueueId.LocalVideo, function () {
                    localVidEl.autoplay = true;
                    localVidEl.srcObject = stream;
                    localVidEl.muted = true;
                    return localVidEl.play();
                  });
                }

                _this2.localAVStream = stream;

                _logger.logger.info("Got local AV stream with id " + _this2.localAVStream.id);

                setTracksEnabled(stream.getAudioTracks(), true);
                _iterator3 = _createForOfIteratorHelper(stream.getTracks());

                try {
                  for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                    track = _step3.value;

                    _this2.peerConn.addTrack(track, stream);
                  }
                } catch (err) {
                  _iterator3.e(err);
                } finally {
                  _iterator3.f();
                }

                _this2.setState(CallState.CreateAnswer);

                _context2.prev = 10;
                _context2.next = 13;
                return _this2.peerConn.createAnswer();

              case 13:
                myAnswer = _context2.sent;
                _context2.next = 21;
                break;

              case 16:
                _context2.prev = 16;
                _context2.t0 = _context2["catch"](10);

                _logger.logger.debug("Failed to create answer: ", _context2.t0);

                _this2.terminate(CallParty.Local, CallErrorCode.CreateAnswer, true);

                return _context2.abrupt("return");

              case 21:
                _context2.prev = 21;
                _context2.next = 24;
                return _this2.peerConn.setLocalDescription(myAnswer);

              case 24:
                _this2.setState(CallState.Connecting); // Allow a short time for initial candidates to be gathered


                _context2.next = 27;
                return new Promise(function (resolve) {
                  setTimeout(resolve, 200);
                });

              case 27:
                _this2.sendAnswer();

                _context2.next = 35;
                break;

              case 30:
                _context2.prev = 30;
                _context2.t1 = _context2["catch"](21);

                _logger.logger.debug("Error setting local description!", _context2.t1);

                _this2.terminate(CallParty.Local, CallErrorCode.SetLocalDescription, true);

                return _context2.abrupt("return");

              case 35:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, null, [[10, 16], [21, 30]]);
      }));

      return function (_x2) {
        return _ref2.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "gotLocalIceCandidate", function (event) {
      if (event.candidate) {
        _logger.logger.debug("Got local ICE " + event.candidate.sdpMid + " candidate: " + event.candidate.candidate);

        if (_this2.callHasEnded()) return; // As with the offer, note we need to make a copy of this object, not
        // pass the original: that broke in Chrome ~m43.

        if (event.candidate.candidate !== '' || !_this2.sentEndOfCandidates) {
          _this2.queueCandidate(event.candidate);

          if (event.candidate.candidate === '') _this2.sentEndOfCandidates = true;
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onIceGatheringStateChange", function (event) {
      _logger.logger.debug("ice gathering state changed to " + _this2.peerConn.iceGatheringState);

      if (_this2.peerConn.iceGatheringState === 'complete' && !_this2.sentEndOfCandidates) {
        // If we didn't get an empty-string candidate to signal the end of candidates,
        // create one ourselves now gathering has finished.
        // We cast because the interface lists all the properties as required but we
        // only want to send 'candidate'
        // XXX: We probably want to send either sdpMid or sdpMLineIndex, as it's not strictly
        // correct to have a candidate that lacks both of these. We'd have to figure out what
        // previous candidates had been sent with and copy them.
        var c = {
          candidate: ''
        };

        _this2.queueCandidate(c);

        _this2.sentEndOfCandidates = true;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "gotLocalOffer", /*#__PURE__*/function () {
      var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(description) {
        var _content;

        var keyName, eventType, content, code, message;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _logger.logger.debug("Created offer: ", description);

                if (!_this2.callHasEnded()) {
                  _context3.next = 4;
                  break;
                }

                _logger.logger.debug("Ignoring newly created offer on call ID " + _this2.callId + " because the call has ended");

                return _context3.abrupt("return");

              case 4:
                _context3.prev = 4;
                _context3.next = 7;
                return _this2.peerConn.setLocalDescription(description);

              case 7:
                _context3.next = 14;
                break;

              case 9:
                _context3.prev = 9;
                _context3.t0 = _context3["catch"](4);

                _logger.logger.debug("Error setting local description!", _context3.t0);

                _this2.terminate(CallParty.Local, CallErrorCode.SetLocalDescription, true);

                return _context3.abrupt("return");

              case 14:
                if (!(_this2.peerConn.iceGatheringState === 'gathering')) {
                  _context3.next = 17;
                  break;
                }

                _context3.next = 17;
                return new Promise(function (resolve) {
                  setTimeout(resolve, 200);
                });

              case 17:
                if (!_this2.callHasEnded()) {
                  _context3.next = 19;
                  break;
                }

                return _context3.abrupt("return");

              case 19:
                keyName = _this2.state === CallState.CreateOffer ? 'offer' : 'description';
                eventType = _this2.state === CallState.CreateOffer ? _event.EventType.CallInvite : _event.EventType.CallNegotiate;
                content = (_content = {}, (0, _defineProperty2["default"])(_content, keyName, _this2.peerConn.localDescription), (0, _defineProperty2["default"])(_content, "lifetime", CALL_TIMEOUT_MS), _content); // Get rid of any candidates waiting to be sent: they'll be included in the local
                // description we just got and will send in the offer.

                _logger.logger.info("Discarding ".concat(_this2.candidateSendQueue.length, " candidates that will be sent in offer"));

                _this2.candidateSendQueue = [];
                _context3.prev = 24;
                _context3.next = 27;
                return _this2.sendVoipEvent(eventType, content);

              case 27:
                _this2.sendCandidateQueue();

                if (_this2.state === CallState.CreateOffer) {
                  _this2.inviteOrAnswerSent = true;

                  _this2.setState(CallState.InviteSent);

                  _this2.inviteTimeout = setTimeout(function () {
                    _this2.inviteTimeout = null;

                    if (_this2.state === CallState.InviteSent) {
                      _this2.hangup(CallErrorCode.InviteTimeout, false);
                    }
                  }, CALL_TIMEOUT_MS);
                }

                _context3.next = 40;
                break;

              case 31:
                _context3.prev = 31;
                _context3.t1 = _context3["catch"](24);

                _this2.client.cancelPendingEvent(_context3.t1.event);

                code = CallErrorCode.SignallingFailed;
                message = "Signalling failed";

                if (_this2.state === CallState.CreateOffer) {
                  code = CallErrorCode.SendInvite;
                  message = "Failed to send invite";
                }

                if (_context3.t1.name == 'UnknownDeviceError') {
                  code = CallErrorCode.UnknownDevices;
                  message = "Unknown devices present in the room";
                }

                _this2.emit(CallEvent.Error, new CallError(code, message, _context3.t1));

                _this2.terminate(CallParty.Local, code, false);

              case 40:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, null, [[4, 9], [24, 31]]);
      }));

      return function (_x3) {
        return _ref3.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "getLocalOfferFailed", function (err) {
      _logger.logger.error("Failed to get local offer", err);

      _this2.emit(CallEvent.Error, new CallError(CallErrorCode.LocalOfferFailed, "Failed to get local offer!", err));

      _this2.terminate(CallParty.Local, CallErrorCode.LocalOfferFailed, false);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "getUserMediaFailed", function (err) {
      if (_this2.successor) {
        _this2.successor.getUserMediaFailed(err);

        return;
      }

      _logger.logger.warn("Failed to get user media - ending call", err);

      _this2.emit(CallEvent.Error, new CallError(CallErrorCode.NoUserMedia, "Couldn't start capturing media! Is your microphone set up and " + "does this app have permission?", err));

      _this2.terminate(CallParty.Local, CallErrorCode.NoUserMedia, false);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onIceConnectionStateChanged", function () {
      if (_this2.callHasEnded()) {
        return; // because ICE can still complete as we're ending the call
      }

      _logger.logger.debug("ICE connection state changed to: " + _this2.peerConn.iceConnectionState); // ideally we'd consider the call to be connected when we get media but
      // chrome doesn't implement any of the 'onstarted' events yet


      if (_this2.peerConn.iceConnectionState == 'connected') {
        _this2.setState(CallState.Connected);
      } else if (_this2.peerConn.iceConnectionState == 'failed') {
        _this2.hangup(CallErrorCode.IceFailed, false);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onSignallingStateChanged", function () {
      _logger.logger.debug("call " + _this2.callId + ": Signalling state changed to: " + _this2.peerConn.signalingState);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onTrack", function (ev) {
      if (ev.streams.length === 0) {
        _logger.logger.warn("Streamless ".concat(ev.track.kind, " found: ignoring."));

        return;
      } // If we already have a stream, check this track is from the same one


      if (_this2.remoteStream && ev.streams[0].id !== _this2.remoteStream.id) {
        _logger.logger.warn("Ignoring new stream ID ".concat(ev.streams[0].id, ": we already have stream ID ").concat(_this2.remoteStream.id));

        return;
      }

      if (!_this2.remoteStream) {
        _logger.logger.info("Got remote stream with id " + ev.streams[0].id);
      } // Note that we check by ID above and always set the remote stream: Chrome appears
      // to make new stream objects when tranciever directionality is changed and the 'active'
      // status of streams change


      _this2.remoteStream = ev.streams[0];

      _logger.logger.debug("Track id ".concat(ev.track.id, " of kind ").concat(ev.track.kind, " added"));

      if (ev.track.kind === 'video') {
        if (_this2.remoteVideoElement) {
          _this2.queueMediaOperation(MediaQueueId.RemoteVideo, /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
            return _regenerator["default"].wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    _this2.remoteVideoElement.srcObject = _this2.remoteStream;
                    _context4.prev = 1;
                    _context4.next = 4;
                    return _this2.remoteVideoElement.play();

                  case 4:
                    _context4.next = 9;
                    break;

                  case 6:
                    _context4.prev = 6;
                    _context4.t0 = _context4["catch"](1);

                    _logger.logger.error("Failed to play remote video element", _context4.t0);

                  case 9:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _callee4, null, [[1, 6]]);
          })));
        }
      } else {
        if (_this2.remoteAudioElement) _this2.playRemoteAudio();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onNegotiationNeeded", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
      var myOffer;
      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _logger.logger.info("Negotation is needed!");

              if (!(_this2.state !== CallState.CreateOffer && _this2.opponentVersion === 0)) {
                _context5.next = 4;
                break;
              }

              _logger.logger.info("Opponent does not support renegotiation: ignoring negotiationneeded event");

              return _context5.abrupt("return");

            case 4:
              _this2.makingOffer = true;
              _context5.prev = 5;
              _context5.next = 8;
              return _this2.peerConn.createOffer();

            case 8:
              myOffer = _context5.sent;
              _context5.next = 11;
              return _this2.gotLocalOffer(myOffer);

            case 11:
              _context5.next = 17;
              break;

            case 13:
              _context5.prev = 13;
              _context5.t0 = _context5["catch"](5);

              _this2.getLocalOfferFailed(_context5.t0);

              return _context5.abrupt("return");

            case 17:
              _context5.prev = 17;
              _this2.makingOffer = false;
              return _context5.finish(17);

            case 20:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, null, [[5, 13, 17, 20]]);
    })));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onHangupReceived", function (msg) {
      _logger.logger.debug("Hangup received"); // party ID must match (our chosen partner hanging up the call) or be undefined (we haven't chosen
      // a partner yet but we're treating the hangup as a reject as per VoIP v0)


      if (!_this2.partyIdMatches(msg) && _this2.opponentPartyId !== undefined) {
        _logger.logger.info("Ignoring message from party ID ".concat(msg.party_id, ": our partner is ").concat(_this2.opponentPartyId));

        return;
      } // default reason is user_hangup


      _this2.terminate(CallParty.Remote, msg.reason || CallErrorCode.UserHangup, true);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onRejectReceived", function (msg) {
      _logger.logger.debug("Reject received"); // No need to check party_id for reject because if we'd received either
      // an answer or reject, we wouldn't be in state InviteSent


      if (_this2.state === CallState.InviteSent) {
        _this2.terminate(CallParty.Remote, CallErrorCode.UserHangup, true);
      } else {
        _logger.logger.debug("Call is in state: ".concat(_this2.state, ": ignoring reject"));
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onAnsweredElsewhere", function (msg) {
      _logger.logger.debug("Answered elsewhere");

      _this2.terminate(CallParty.Remote, CallErrorCode.AnsweredElsewhere, true);
    });
    _this2.roomId = opts.roomId;
    _this2.client = opts.client;
    _this2.type = null;
    _this2.forceTURN = opts.forceTURN;
    _this2.ourPartyId = _this2.client.deviceId; // Array of Objects with urls, username, credential keys

    _this2.turnServers = opts.turnServers || [];

    if (_this2.turnServers.length === 0 && _this2.client.isFallbackICEServerAllowed()) {
      _this2.turnServers.push({
        urls: [FALLBACK_ICE_SERVER]
      });
    }

    var _iterator4 = _createForOfIteratorHelper(_this2.turnServers),
        _step4;

    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var server = _step4.value;
        utils.checkObjectHasKeys(server, ["urls"]);
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }

    _this2.callId = "c" + new Date().getTime() + Math.random();
    _this2.state = CallState.Fledgling; // A queue for candidates waiting to go out.
    // We try to amalgamate candidates into a single candidate message where
    // possible

    _this2.candidateSendQueue = [];
    _this2.candidateSendTries = 0; // Lookup from opaque queue ID to a promise for media element operations that
    // need to be serialised into a given queue.  Store this per-MatrixCall on the
    // assumption that multiple matrix calls will never compete for control of the
    // same DOM elements.

    _this2.mediaPromises = Object.create(null);
    _this2.sentEndOfCandidates = false;
    _this2.inviteOrAnswerSent = false;
    _this2.makingOffer = false;
    _this2.remoteOnHold = false;
    _this2.micMuted = false;
    _this2.vidMuted = false;
    return _this2;
  }
  /**
   * Place a voice call to this room.
   * @throws If you have not specified a listener for 'error' events.
   */


  (0, _createClass2["default"])(MatrixCall, [{
    key: "placeVoiceCall",
    value: function placeVoiceCall() {
      _logger.logger.debug("placeVoiceCall");

      this.checkForErrorListener();
      this.placeCallWithConstraints(getUserMediaVideoContraints(CallType.Voice));
      this.type = CallType.Voice;
    }
    /**
     * Place a video call to this room.
     * @param {Element} remoteVideoElement a <code>&lt;video&gt;</code> DOM element
     * to render video to.
     * @param {Element} localVideoElement a <code>&lt;video&gt;</code> DOM element
     * to render the local camera preview.
     * @throws If you have not specified a listener for 'error' events.
     */

  }, {
    key: "placeVideoCall",
    value: function placeVideoCall(remoteVideoElement, localVideoElement) {
      _logger.logger.debug("placeVideoCall");

      this.checkForErrorListener();
      this.localVideoElement = localVideoElement;
      this.remoteVideoElement = remoteVideoElement;
      this.placeCallWithConstraints(getUserMediaVideoContraints(CallType.Video));
      this.type = CallType.Video;
    }
    /**
     * Place a screen-sharing call to this room. This includes audio.
     * <b>This method is EXPERIMENTAL and subject to change without warning. It
     * only works in Google Chrome and Firefox >= 44.</b>
     * @param {Element} remoteVideoElement a <code>&lt;video&gt;</code> DOM element
     * to render video to.
     * @param {Element} localVideoElement a <code>&lt;video&gt;</code> DOM element
     * to render the local camera preview.
     * @throws If you have not specified a listener for 'error' events.
     */

  }, {
    key: "placeScreenSharingCall",
    value: function () {
      var _placeScreenSharingCall = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(remoteVideoElement, localVideoElement) {
        var audioConstraints;
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _logger.logger.debug("placeScreenSharingCall");

                this.checkForErrorListener();
                this.localVideoElement = localVideoElement;
                this.remoteVideoElement = remoteVideoElement;
                _context6.prev = 4;
                _context6.next = 7;
                return navigator.mediaDevices.getDisplayMedia({
                  'audio': false
                });

              case 7:
                this.screenSharingStream = _context6.sent;

                _logger.logger.debug("Got screen stream, requesting audio stream...");

                audioConstraints = getUserMediaVideoContraints(CallType.Voice);
                this.placeCallWithConstraints(audioConstraints);
                _context6.next = 16;
                break;

              case 13:
                _context6.prev = 13;
                _context6.t0 = _context6["catch"](4);
                this.emit(CallEvent.Error, new CallError(CallErrorCode.NoUserMedia, "Failed to get screen-sharing stream: ", _context6.t0));

              case 16:
                this.type = CallType.Video;

              case 17:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this, [[4, 13]]);
      }));

      function placeScreenSharingCall(_x4, _x5) {
        return _placeScreenSharingCall.apply(this, arguments);
      }

      return placeScreenSharingCall;
    }()
  }, {
    key: "queueMediaOperation",
    value: function queueMediaOperation(queueId, operation) {
      if (this.mediaPromises[queueId] !== undefined) {
        this.mediaPromises[queueId] = this.mediaPromises[queueId].then(operation, operation);
      } else {
        this.mediaPromises[queueId] = Promise.resolve(operation());
      }
    }
    /**
     * Retrieve the local <code>&lt;video&gt;</code> DOM element.
     * @return {Element} The dom element
     */

  }, {
    key: "getLocalVideoElement",
    value: function getLocalVideoElement() {
      return this.localVideoElement;
    }
    /**
     * Retrieve the remote <code>&lt;video&gt;</code> DOM element
     * used for playing back video capable streams.
     * @return {Element} The dom element
     */

  }, {
    key: "getRemoteVideoElement",
    value: function getRemoteVideoElement() {
      return this.remoteVideoElement;
    }
    /**
     * Retrieve the remote <code>&lt;audio&gt;</code> DOM element
     * used for playing back audio only streams.
     * @return {Element} The dom element
     */

  }, {
    key: "getRemoteAudioElement",
    value: function getRemoteAudioElement() {
      return this.remoteAudioElement;
    }
    /**
     * Set the local <code>&lt;video&gt;</code> DOM element. If this call is active,
     * video will be rendered to it immediately.
     * @param {Element} element The <code>&lt;video&gt;</code> DOM element.
     */

  }, {
    key: "setLocalVideoElement",
    value: function setLocalVideoElement(element) {
      var _this3 = this;

      this.localVideoElement = element;

      if (element && this.localAVStream && this.type === CallType.Video) {
        element.autoplay = true;
        this.queueMediaOperation(MediaQueueId.LocalVideo, function () {
          element.srcObject = _this3.localAVStream;
          element.muted = true;
          return element.play();
        });
      }
    }
    /**
     * Set the remote <code>&lt;video&gt;</code> DOM element. If this call is active,
     * the first received video-capable stream will be rendered to it immediately.
     * @param {Element} element The <code>&lt;video&gt;</code> DOM element.
     */

  }, {
    key: "setRemoteVideoElement",
    value: function setRemoteVideoElement(element) {
      var _this4 = this;

      if (element === this.remoteVideoElement) return;
      element.autoplay = true; // if we already have an audio element set, use that instead and mute the audio
      // on this video element.

      if (this.remoteAudioElement) element.muted = true;
      this.remoteVideoElement = element;

      if (this.remoteStream) {
        this.queueMediaOperation(MediaQueueId.RemoteVideo, function () {
          element.srcObject = _this4.remoteStream;
          return element.play();
        });
      }
    }
    /**
     * Set the remote <code>&lt;audio&gt;</code> DOM element. If this call is active,
     * the first received audio-only stream will be rendered to it immediately.
     * The audio will *not* be rendered from the remoteVideoElement.
     * @param {Element} element The <code>&lt;video&gt;</code> DOM element.
     */

  }, {
    key: "setRemoteAudioElement",
    value: function () {
      var _setRemoteAudioElement = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(element) {
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                if (!(element === this.remoteAudioElement)) {
                  _context7.next = 2;
                  break;
                }

                return _context7.abrupt("return");

              case 2:
                if (this.remoteVideoElement) this.remoteVideoElement.muted = true;
                this.remoteAudioElement = element;
                this.remoteAudioElement.muted = false;
                if (this.remoteStream) this.playRemoteAudio();

              case 6:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function setRemoteAudioElement(_x6) {
        return _setRemoteAudioElement.apply(this, arguments);
      }

      return setRemoteAudioElement;
    }()
    /**
     * Configure this call from an invite event. Used by MatrixClient.
     * @param {MatrixEvent} event The m.call.invite event
     */

  }, {
    key: "initWithInvite",
    value: function () {
      var _initWithInvite = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(event) {
        var _this5 = this;

        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                this.msg = event.getContent();
                this.peerConn = this.createPeerConnection();
                _context8.prev = 2;
                _context8.next = 5;
                return this.peerConn.setRemoteDescription(this.msg.offer);

              case 5:
                _context8.next = 12;
                break;

              case 7:
                _context8.prev = 7;
                _context8.t0 = _context8["catch"](2);

                _logger.logger.debug("Failed to set remote description", _context8.t0);

                this.terminate(CallParty.Local, CallErrorCode.SetRemoteDescription, false);
                return _context8.abrupt("return");

              case 12:
                if (!(!this.remoteStream || this.remoteStream.getTracks().length === 0)) {
                  _context8.next = 16;
                  break;
                }

                _logger.logger.error("No remote stream or no tracks after setting remote description!");

                this.terminate(CallParty.Local, CallErrorCode.SetRemoteDescription, false);
                return _context8.abrupt("return");

              case 16:
                this.type = this.remoteStream.getTracks().some(function (t) {
                  return t.kind === 'video';
                }) ? CallType.Video : CallType.Voice;
                this.setState(CallState.Ringing);
                this.direction = CallDirection.Inbound;
                this.opponentVersion = this.msg.version;
                this.opponentPartyId = this.msg.party_id || null;

                if (event.getLocalAge()) {
                  setTimeout(function () {
                    if (_this5.state == CallState.Ringing) {
                      _logger.logger.debug("Call invite has expired. Hanging up.");

                      _this5.hangupParty = CallParty.Remote; // effectively

                      _this5.setState(CallState.Ended);

                      _this5.stopAllMedia();

                      if (_this5.peerConn.signalingState != 'closed') {
                        _this5.peerConn.close();
                      }

                      _this5.emit(CallEvent.Hangup);
                    }
                  }, this.msg.lifetime - event.getLocalAge());
                }

              case 22:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this, [[2, 7]]);
      }));

      function initWithInvite(_x7) {
        return _initWithInvite.apply(this, arguments);
      }

      return initWithInvite;
    }()
    /**
     * Configure this call from a hangup or reject event. Used by MatrixClient.
     * @param {MatrixEvent} event The m.call.hangup event
     */

  }, {
    key: "initWithHangup",
    value: function initWithHangup(event) {
      // perverse as it may seem, sometimes we want to instantiate a call with a
      // hangup message (because when getting the state of the room on load, events
      // come in reverse order and we want to remember that a call has been hung up)
      this.msg = event.getContent();
      this.setState(CallState.Ended);
    }
    /**
     * Answer a call.
     */

  }, {
    key: "answer",
    value: function () {
      var _answer = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9() {
        var constraints, mediaStream;
        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                if (!this.inviteOrAnswerSent) {
                  _context9.next = 2;
                  break;
                }

                return _context9.abrupt("return");

              case 2:
                _logger.logger.debug("Answering call ".concat(this.callId, " of type ").concat(this.type));

                if (!(!this.localAVStream && !this.waitForLocalAVStream)) {
                  _context9.next = 22;
                  break;
                }

                constraints = getUserMediaVideoContraints(this.type);

                _logger.logger.log("Getting user media with constraints", constraints);

                this.setState(CallState.WaitLocalMedia);
                this.waitForLocalAVStream = true;
                _context9.prev = 8;
                _context9.next = 11;
                return navigator.mediaDevices.getUserMedia(constraints);

              case 11:
                mediaStream = _context9.sent;
                this.waitForLocalAVStream = false;
                this.gotUserMediaForAnswer(mediaStream);
                _context9.next = 20;
                break;

              case 16:
                _context9.prev = 16;
                _context9.t0 = _context9["catch"](8);
                this.getUserMediaFailed(_context9.t0);
                return _context9.abrupt("return");

              case 20:
                _context9.next = 23;
                break;

              case 22:
                if (this.localAVStream) {
                  this.gotUserMediaForAnswer(this.localAVStream);
                } else if (this.waitForLocalAVStream) {
                  this.setState(CallState.WaitLocalMedia);
                }

              case 23:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this, [[8, 16]]);
      }));

      function answer() {
        return _answer.apply(this, arguments);
      }

      return answer;
    }()
    /**
     * Replace this call with a new call, e.g. for glare resolution. Used by
     * MatrixClient.
     * @param {MatrixCall} newCall The new call.
     */

  }, {
    key: "replacedBy",
    value: function replacedBy(newCall) {
      _logger.logger.debug(this.callId + " being replaced by " + newCall.callId);

      if (this.state === CallState.WaitLocalMedia) {
        _logger.logger.debug("Telling new call to wait for local media");

        newCall.waitForLocalAVStream = true;
      } else if (this.state === CallState.CreateOffer) {
        _logger.logger.debug("Handing local stream to new call");

        newCall.gotUserMediaForAnswer(this.localAVStream);
        delete this.localAVStream;
      } else if (this.state === CallState.InviteSent) {
        _logger.logger.debug("Handing local stream to new call");

        newCall.gotUserMediaForAnswer(this.localAVStream);
        delete this.localAVStream;
      }

      newCall.localVideoElement = this.localVideoElement;
      newCall.remoteVideoElement = this.remoteVideoElement;
      newCall.remoteAudioElement = this.remoteAudioElement;
      this.successor = newCall;
      this.emit(CallEvent.Replaced, newCall);
      this.hangup(CallErrorCode.Replaced, true);
    }
    /**
     * Hangup a call.
     * @param {string} reason The reason why the call is being hung up.
     * @param {boolean} suppressEvent True to suppress emitting an event.
     */

  }, {
    key: "hangup",
    value: function hangup(reason, suppressEvent) {
      if (this.callHasEnded()) return;

      _logger.logger.debug("Ending call " + this.callId);

      this.terminate(CallParty.Local, reason, !suppressEvent);
      var content = {}; // Continue to send no reason for user hangups temporarily, until
      // clients understand the user_hangup reason (voip v1)

      if (reason !== CallErrorCode.UserHangup) content['reason'] = reason;
      this.sendVoipEvent(_event.EventType.CallHangup, {});
    }
    /**
     * Reject a call
     * This used to be done by calling hangup, but is a separate method and protocol
     * event as of MSC2746.
     */

  }, {
    key: "reject",
    value: function reject() {
      if (this.state !== CallState.Ringing) {
        throw Error("Call must be in 'ringing' state to reject!");
      }

      if (this.opponentVersion < 1) {
        _logger.logger.info("Opponent version is less than 1 (".concat(this.opponentVersion, "): sending hangup instead of reject"));

        this.hangup(CallErrorCode.UserHangup, true);
        return;
      }

      _logger.logger.debug("Rejecting call: " + this.callId);

      this.terminate(CallParty.Local, CallErrorCode.UserHangup, true);
      this.sendVoipEvent(_event.EventType.CallReject, {});
    }
    /**
     * Set whether our outbound video should be muted or not.
     * @param {boolean} muted True to mute the outbound video.
     */

  }, {
    key: "setLocalVideoMuted",
    value: function setLocalVideoMuted(muted) {
      this.vidMuted = muted;
      this.updateMuteStatus();
    }
    /**
     * Check if local video is muted.
     *
     * If there are multiple video tracks, <i>all</i> of the tracks need to be muted
     * for this to return true. This means if there are no video tracks, this will
     * return true.
     * @return {Boolean} True if the local preview video is muted, else false
     * (including if the call is not set up yet).
     */

  }, {
    key: "isLocalVideoMuted",
    value: function isLocalVideoMuted() {
      return this.vidMuted;
    }
    /**
     * Set whether the microphone should be muted or not.
     * @param {boolean} muted True to mute the mic.
     */

  }, {
    key: "setMicrophoneMuted",
    value: function setMicrophoneMuted(muted) {
      this.micMuted = muted;
      this.updateMuteStatus();
    }
    /**
     * Check if the microphone is muted.
     *
     * If there are multiple audio tracks, <i>all</i> of the tracks need to be muted
     * for this to return true. This means if there are no audio tracks, this will
     * return true.
     * @return {Boolean} True if the mic is muted, else false (including if the call
     * is not set up yet).
     */

  }, {
    key: "isMicrophoneMuted",
    value: function isMicrophoneMuted() {
      return this.micMuted;
    }
    /**
     * @returns true if we have put the party on the other side of the call on hold
     * (that is, we are signalling to them that we are not listening)
     */

  }, {
    key: "isRemoteOnHold",
    value: function isRemoteOnHold() {
      return this.remoteOnHold;
    }
  }, {
    key: "setRemoteOnHold",
    value: function setRemoteOnHold(onHold) {
      if (this.isRemoteOnHold() === onHold) return;
      this.remoteOnHold = onHold;

      var _iterator5 = _createForOfIteratorHelper(this.peerConn.getTransceivers()),
          _step5;

      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var tranceiver = _step5.value;
          // We set 'inactive' rather than 'sendonly' because we're not planning on
          // playing music etc. to the other side.
          tranceiver.direction = onHold ? 'inactive' : 'sendrecv';
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }

      this.updateMuteStatus();
    }
    /**
     * Indicates whether we are 'on hold' to the remote party (ie. if true,
     * they cannot hear us). Note that this will return true when we put the
     * remote on hold too due to the way hold is implemented (since we don't
     * wish to play hold music when we put a call on hold, we use 'inactive'
     * rather than 'sendonly')
     * @returns true if the other party has put us on hold
     */

  }, {
    key: "isLocalOnHold",
    value: function isLocalOnHold() {
      if (this.state !== CallState.Connected) return false;
      var callOnHold = true; // We consider a call to be on hold only if *all* the tracks are on hold
      // (is this the right thing to do?)

      var _iterator6 = _createForOfIteratorHelper(this.peerConn.getTransceivers()),
          _step6;

      try {
        for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
          var tranceiver = _step6.value;
          var trackOnHold = ['inactive', 'recvonly'].includes(tranceiver.currentDirection);
          if (!trackOnHold) callOnHold = false;
        }
      } catch (err) {
        _iterator6.e(err);
      } finally {
        _iterator6.f();
      }

      return callOnHold;
    }
  }, {
    key: "updateMuteStatus",
    value: function updateMuteStatus() {
      if (!this.localAVStream) {
        return;
      }

      var micShouldBeMuted = this.micMuted || this.remoteOnHold;
      setTracksEnabled(this.localAVStream.getAudioTracks(), !micShouldBeMuted);
      var vidShouldBeMuted = this.vidMuted || this.remoteOnHold;
      setTracksEnabled(this.localAVStream.getVideoTracks(), !vidShouldBeMuted);
    }
    /**
     * Internal
     * @param {Object} stream
     */

  }, {
    key: "sendAnswer",
    value: function sendAnswer() {
      var _this6 = this;

      var answerContent = {
        answer: {
          sdp: this.peerConn.localDescription.sdp,
          // type is now deprecated as of Matrix VoIP v1, but
          // required to still be sent for backwards compat
          type: this.peerConn.localDescription.type
        }
      }; // We have just taken the local description from the peerconnection which will
      // contain all the local candidates added so far, so we can discard any candidates
      // we had queued up because they'll be in the answer.

      _logger.logger.info("Discarding ".concat(this.candidateSendQueue.length, " candidates that will be sent in answer"));

      this.candidateSendQueue = [];
      this.sendVoipEvent(_event.EventType.CallAnswer, answerContent).then(function () {
        // If this isn't the first time we've tried to send the answer,
        // we may have candidates queued up, so send them now.
        _this6.inviteOrAnswerSent = true;

        _this6.sendCandidateQueue();
      })["catch"](function (error) {
        // We've failed to answer: back to the ringing state
        _this6.setState(CallState.Ringing);

        _this6.client.cancelPendingEvent(error.event);

        var code = CallErrorCode.SendAnswer;
        var message = "Failed to send answer";

        if (error.name == 'UnknownDeviceError') {
          code = CallErrorCode.UnknownDevices;
          message = "Unknown devices present in the room";
        }

        _this6.emit(CallEvent.Error, new CallError(code, message, error));

        throw error;
      });
    }
  }, {
    key: "onRemoteIceCandidatesReceived",
    value: function onRemoteIceCandidatesReceived(ev) {
      if (this.callHasEnded()) {
        //debuglog("Ignoring remote ICE candidate because call has ended");
        return;
      }

      if (!this.partyIdMatches(ev.getContent())) {
        _logger.logger.info("Ignoring candidates from party ID ".concat(ev.getContent().party_id, ": ") + "we have chosen party ID ".concat(this.opponentPartyId));

        return;
      }

      var cands = ev.getContent().candidates;

      if (!cands) {
        _logger.logger.info("Ignoring candidates event with no candidates!");

        return;
      }

      var _iterator7 = _createForOfIteratorHelper(cands),
          _step7;

      try {
        for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
          var cand = _step7.value;

          if ((cand.sdpMid === null || cand.sdpMid === undefined) && (cand.sdpMLineIndex === null || cand.sdpMLineIndex === undefined)) {
            _logger.logger.debug("Ignoring remote ICE candidate with no sdpMid or sdpMLineIndex");

            return;
          }

          _logger.logger.debug("Got remote ICE " + cand.sdpMid + " candidate: " + cand.candidate);

          try {
            this.peerConn.addIceCandidate(cand);
          } catch (err) {
            if (!this.ignoreOffer) {
              _logger.logger.info("Failed to add remore ICE candidate", err);
            }
          }
        }
      } catch (err) {
        _iterator7.e(err);
      } finally {
        _iterator7.f();
      }
    }
    /**
     * Used by MatrixClient.
     * @param {Object} msg
     */

  }, {
    key: "onAnswerReceived",
    value: function () {
      var _onAnswerReceived = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(event) {
        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                if (!this.callHasEnded()) {
                  _context10.next = 2;
                  break;
                }

                return _context10.abrupt("return");

              case 2:
                if (!(this.opponentPartyId !== undefined)) {
                  _context10.next = 5;
                  break;
                }

                _logger.logger.info("Ignoring answer from party ID ".concat(event.getContent().party_id, ": ") + "we already have an answer/reject from ".concat(this.opponentPartyId));

                return _context10.abrupt("return");

              case 5:
                this.opponentVersion = event.getContent().version;
                this.opponentPartyId = event.getContent().party_id || null;
                this.setState(CallState.Connecting);
                _context10.prev = 8;
                _context10.next = 11;
                return this.peerConn.setRemoteDescription(event.getContent().answer);

              case 11:
                _context10.next = 18;
                break;

              case 13:
                _context10.prev = 13;
                _context10.t0 = _context10["catch"](8);

                _logger.logger.debug("Failed to set remote description", _context10.t0);

                this.terminate(CallParty.Local, CallErrorCode.SetRemoteDescription, false);
                return _context10.abrupt("return");

              case 18:
                if (!(this.opponentPartyId !== null)) {
                  _context10.next = 27;
                  break;
                }

                _context10.prev = 19;
                _context10.next = 22;
                return this.sendVoipEvent(_event.EventType.CallSelectAnswer, {
                  selected_party_id: this.opponentPartyId
                });

              case 22:
                _context10.next = 27;
                break;

              case 24:
                _context10.prev = 24;
                _context10.t1 = _context10["catch"](19);

                // This isn't fatal, and will just mean that if another party has raced to answer
                // the call, they won't know they got rejected, so we carry on & don't retry.
                _logger.logger.warn("Failed to send select_answer event", _context10.t1);

              case 27:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this, [[8, 13], [19, 24]]);
      }));

      function onAnswerReceived(_x8) {
        return _onAnswerReceived.apply(this, arguments);
      }

      return onAnswerReceived;
    }()
  }, {
    key: "onSelectAnswerReceived",
    value: function () {
      var _onSelectAnswerReceived = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(event) {
        var selectedPartyId;
        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                if (!(this.direction !== CallDirection.Inbound)) {
                  _context11.next = 3;
                  break;
                }

                _logger.logger.warn("Got select_answer for an outbound call: ignoring");

                return _context11.abrupt("return");

              case 3:
                selectedPartyId = event.getContent().selected_party_id;

                if (!(selectedPartyId === undefined || selectedPartyId === null)) {
                  _context11.next = 7;
                  break;
                }

                _logger.logger.warn("Got nonsensical select_answer with null/undefined selected_party_id: ignoring");

                return _context11.abrupt("return");

              case 7:
                if (selectedPartyId !== this.ourPartyId) {
                  _logger.logger.info("Got select_answer for party ID ".concat(selectedPartyId, ": we are party ID ").concat(this.ourPartyId, ".")); // The other party has picked somebody else's answer


                  this.terminate(CallParty.Remote, CallErrorCode.AnsweredElsewhere, true);
                }

              case 8:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function onSelectAnswerReceived(_x9) {
        return _onSelectAnswerReceived.apply(this, arguments);
      }

      return onSelectAnswerReceived;
    }()
  }, {
    key: "onNegotiateReceived",
    value: function () {
      var _onNegotiateReceived = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(event) {
        var description, polite, offerCollision, prevOnHold, localDescription, nowOnHold;
        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                description = event.getContent().description;

                if (!(!description || !description.sdp || !description.type)) {
                  _context12.next = 4;
                  break;
                }

                _logger.logger.info("Ignoring invalid m.call.negotiate event");

                return _context12.abrupt("return");

              case 4:
                // Politeness always follows the direction of the call: in a glare situation,
                // we pick either the inbound or outbound call, so one side will always be
                // inbound and one outbound
                polite = this.direction === CallDirection.Inbound; // Here we follow the perfect negotiation logic from
                // https://developer.mozilla.org/en-US/docs/Web/API/WebRTC_API/Perfect_negotiation

                offerCollision = description.type == 'offer' && (this.makingOffer || this.peerConn.signalingState != 'stable');
                this.ignoreOffer = !polite && offerCollision;

                if (!this.ignoreOffer) {
                  _context12.next = 10;
                  break;
                }

                _logger.logger.info("Ignoring colliding negotiate event because we're impolite");

                return _context12.abrupt("return");

              case 10:
                prevOnHold = this.isLocalOnHold();
                _context12.prev = 11;
                _context12.next = 14;
                return this.peerConn.setRemoteDescription(description);

              case 14:
                if (!(description.type === 'offer')) {
                  _context12.next = 21;
                  break;
                }

                _context12.next = 17;
                return this.peerConn.createAnswer();

              case 17:
                localDescription = _context12.sent;
                _context12.next = 20;
                return this.peerConn.setLocalDescription(localDescription);

              case 20:
                this.sendVoipEvent(_event.EventType.CallNegotiate, {
                  description: this.peerConn.localDescription
                });

              case 21:
                _context12.next = 26;
                break;

              case 23:
                _context12.prev = 23;
                _context12.t0 = _context12["catch"](11);

                _logger.logger.warn("Failed to complete negotiation", _context12.t0);

              case 26:
                nowOnHold = this.isLocalOnHold();

                if (prevOnHold !== nowOnHold) {
                  this.emit(CallEvent.HoldUnhold, nowOnHold);
                }

              case 28:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this, [[11, 23]]);
      }));

      function onNegotiateReceived(_x10) {
        return _onNegotiateReceived.apply(this, arguments);
      }

      return onNegotiateReceived;
    }()
  }, {
    key: "callHasEnded",
    value: function callHasEnded() {
      // This exists as workaround to typescript trying to be clever and erroring
      // when putting if (this.state === CallState.Ended) return; twice in the same
      // function, even though that function is async.
      return this.state === CallState.Ended;
    }
  }, {
    key: "playRemoteAudio",
    value: function playRemoteAudio() {
      var _this7 = this;

      this.queueMediaOperation(MediaQueueId.RemoteAudio, /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13() {
        return _regenerator["default"].wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _this7.remoteAudioElement.srcObject = _this7.remoteStream; // if audioOutput is non-default:

                _context13.prev = 1;

                if (!audioOutput) {
                  _context13.next = 6;
                  break;
                }

                // This seems quite unreliable in Chrome, although I haven't yet managed to make a jsfiddle where
                // it fails.
                // It seems reliable if you set the sink ID after setting the srcObject and then set the sink ID
                // back to the default after the call is over
                _logger.logger.info("Setting audio sink to " + audioOutput + ", was " + _this7.remoteAudioElement.sinkId);

                _context13.next = 6;
                return _this7.remoteAudioElement.setSinkId(audioOutput);

              case 6:
                _context13.next = 11;
                break;

              case 8:
                _context13.prev = 8;
                _context13.t0 = _context13["catch"](1);

                _logger.logger.warn("Couldn't set requested audio output device: using default", _context13.t0);

              case 11:
                _context13.prev = 11;
                _context13.next = 14;
                return _this7.remoteAudioElement.play();

              case 14:
                _context13.next = 19;
                break;

              case 16:
                _context13.prev = 16;
                _context13.t1 = _context13["catch"](11);

                _logger.logger.error("Failed to play remote video element", _context13.t1);

              case 19:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, null, [[1, 8], [11, 16]]);
      })));
    }
  }, {
    key: "setState",
    value: function setState(state) {
      var oldState = this.state;
      this.state = state;
      this.emit(CallEvent.State, state, oldState);
    }
    /**
     * Internal
     * @param {string} eventType
     * @param {Object} content
     * @return {Promise}
     */

  }, {
    key: "sendVoipEvent",
    value: function sendVoipEvent(eventType, content) {
      return this.client.sendEvent(this.roomId, eventType, Object.assign({}, content, {
        version: VOIP_PROTO_VERSION,
        call_id: this.callId,
        party_id: this.ourPartyId
      }));
    }
  }, {
    key: "queueCandidate",
    value: function queueCandidate(content) {
      var _this8 = this;

      // Sends candidates with are sent in a special way because we try to amalgamate
      // them into one message
      this.candidateSendQueue.push(content); // Don't send the ICE candidates yet if the call is in the ringing state: this
      // means we tried to pick (ie. started generating candidates) and then failed to
      // send the answer and went back to the ringing state. Queue up the candidates
      // to send if we sucessfully send the answer.
      // Equally don't send if we haven't yet sent the answer because we can send the
      // first batch of candidates along with the answer

      if (this.state === CallState.Ringing || !this.inviteOrAnswerSent) return; // MSC2746 reccomends these values (can be quite long when calling because the
      // callee will need a while to answer the call)

      var delay = this.direction === CallDirection.Inbound ? 500 : 2000;

      if (this.candidateSendTries === 0) {
        setTimeout(function () {
          _this8.sendCandidateQueue();
        }, delay);
      }
    }
  }, {
    key: "terminate",
    value: function terminate(hangupParty, hangupReason, shouldEmit) {
      var _this9 = this;

      if (this.callHasEnded()) return;

      if (this.inviteTimeout) {
        clearTimeout(this.inviteTimeout);
        this.inviteTimeout = null;
      }

      var remoteVid = this.getRemoteVideoElement();
      var remoteAud = this.getRemoteAudioElement();
      var localVid = this.getLocalVideoElement();

      if (remoteVid) {
        this.queueMediaOperation(MediaQueueId.RemoteVideo, function () {
          remoteVid.pause();
          remoteVid.srcObject = null;
        });
      }

      if (remoteAud) {
        this.queueMediaOperation(MediaQueueId.RemoteAudio, /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14() {
          return _regenerator["default"].wrap(function _callee14$(_context14) {
            while (1) {
              switch (_context14.prev = _context14.next) {
                case 0:
                  remoteAud.pause();
                  remoteAud.srcObject = null;
                  _context14.prev = 2;
                  _context14.next = 5;
                  return _this9.remoteAudioElement.setSinkId('');

                case 5:
                  _context14.next = 10;
                  break;

                case 7:
                  _context14.prev = 7;
                  _context14.t0 = _context14["catch"](2);

                  _logger.logger.warn("Failed to set sink ID back to default");

                case 10:
                case "end":
                  return _context14.stop();
              }
            }
          }, _callee14, null, [[2, 7]]);
        })));
      }

      if (localVid) {
        this.queueMediaOperation(MediaQueueId.LocalVideo, function () {
          localVid.pause();
          localVid.srcObject = null;
        });
      }

      this.hangupParty = hangupParty;
      this.hangupReason = hangupReason;
      this.setState(CallState.Ended);
      this.stopAllMedia();

      if (this.peerConn && this.peerConn.signalingState !== 'closed') {
        this.peerConn.close();
      }

      if (shouldEmit) {
        this.emit(CallEvent.Hangup, this);
      }
    }
  }, {
    key: "stopAllMedia",
    value: function stopAllMedia() {
      _logger.logger.debug("stopAllMedia (stream=".concat(this.localAVStream, ")"));

      if (this.localAVStream) {
        var _iterator8 = _createForOfIteratorHelper(this.localAVStream.getTracks()),
            _step8;

        try {
          for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
            var track = _step8.value;
            track.stop();
          }
        } catch (err) {
          _iterator8.e(err);
        } finally {
          _iterator8.f();
        }
      }

      if (this.screenSharingStream) {
        var _iterator9 = _createForOfIteratorHelper(this.screenSharingStream.getTracks()),
            _step9;

        try {
          for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
            var _track = _step9.value;

            _track.stop();
          }
        } catch (err) {
          _iterator9.e(err);
        } finally {
          _iterator9.f();
        }
      }

      if (this.remoteStream) {
        var _iterator10 = _createForOfIteratorHelper(this.remoteStream.getTracks()),
            _step10;

        try {
          for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
            var _track2 = _step10.value;

            _track2.stop();
          }
        } catch (err) {
          _iterator10.e(err);
        } finally {
          _iterator10.f();
        }
      }
    }
  }, {
    key: "checkForErrorListener",
    value: function checkForErrorListener() {
      if (this.listeners("error").length === 0) {
        throw new Error("You MUST attach an error listener using call.on('error', function() {})");
      }
    }
  }, {
    key: "sendCandidateQueue",
    value: function sendCandidateQueue() {
      var _this10 = this;

      if (this.candidateSendQueue.length === 0) {
        return;
      }

      var cands = this.candidateSendQueue;
      this.candidateSendQueue = [];
      ++this.candidateSendTries;
      var content = {
        candidates: cands
      };

      _logger.logger.debug("Attempting to send " + cands.length + " candidates");

      this.sendVoipEvent(_event.EventType.CallCandidates, content).then(function () {
        _this10.candidateSendTries = 0;

        _this10.sendCandidateQueue();
      }, function (error) {
        for (var i = 0; i < cands.length; i++) {
          _this10.candidateSendQueue.push(cands[i]);
        }

        if (_this10.candidateSendTries > 5) {
          _logger.logger.debug("Failed to send candidates on attempt " + _this10.candidateSendTries + ". Giving up for now.", error);

          _this10.candidateSendTries = 0;
          return;
        }

        var delayMs = 500 * Math.pow(2, _this10.candidateSendTries);
        ++_this10.candidateSendTries;

        _logger.logger.debug("Failed to send candidates. Retrying in " + delayMs + "ms", error);

        setTimeout(function () {
          _this10.sendCandidateQueue();
        }, delayMs);
      });
    }
  }, {
    key: "placeCallWithConstraints",
    value: function () {
      var _placeCallWithConstraints = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(constraints) {
        var mediaStream;
        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _logger.logger.log("Getting user media with constraints", constraints); // XXX Find a better way to do this


                this.client._callEventHandler.calls.set(this.callId, this);

                this.setState(CallState.WaitLocalMedia);
                this.direction = CallDirection.Outbound;
                this.config = constraints; // It would be really nice if we could start gathering candidates at this point
                // so the ICE agent could be gathering while we open our media devices: we already
                // know the type of the call and therefore what tracks we want to send.
                // Perhaps we could do this by making fake tracks now and then using replaceTrack()
                // once we have the actual tracks? (Can we make fake tracks?)

                _context15.prev = 5;
                _context15.next = 8;
                return navigator.mediaDevices.getUserMedia(constraints);

              case 8:
                mediaStream = _context15.sent;
                this.gotUserMediaForInvite(mediaStream);
                _context15.next = 16;
                break;

              case 12:
                _context15.prev = 12;
                _context15.t0 = _context15["catch"](5);
                this.getUserMediaFailed(_context15.t0);
                return _context15.abrupt("return");

              case 16:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15, this, [[5, 12]]);
      }));

      function placeCallWithConstraints(_x11) {
        return _placeCallWithConstraints.apply(this, arguments);
      }

      return placeCallWithConstraints;
    }()
  }, {
    key: "createPeerConnection",
    value: function createPeerConnection() {
      var pc = new window.RTCPeerConnection({
        iceTransportPolicy: this.forceTURN ? 'relay' : undefined,
        iceServers: this.turnServers
      }); // 'connectionstatechange' would be better, but firefox doesn't implement that.

      pc.addEventListener('iceconnectionstatechange', this.onIceConnectionStateChanged);
      pc.addEventListener('signalingstatechange', this.onSignallingStateChanged);
      pc.addEventListener('icecandidate', this.gotLocalIceCandidate);
      pc.addEventListener('icegatheringstatechange', this.onIceGatheringStateChange);
      pc.addEventListener('track', this.onTrack);
      pc.addEventListener('negotiationneeded', this.onNegotiationNeeded);
      return pc;
    }
  }, {
    key: "partyIdMatches",
    value: function partyIdMatches(msg) {
      // They must either match or both be absent (in which case opponentPartyId will be null)
      var msgPartyId = msg.party_id || null;
      return msgPartyId === this.opponentPartyId;
    }
  }]);
  return MatrixCall;
}(_events.EventEmitter);

exports.MatrixCall = MatrixCall;

function setTracksEnabled(tracks, enabled) {
  for (var i = 0; i < tracks.length; i++) {
    tracks[i].enabled = enabled;
  }
}

function getUserMediaVideoContraints(callType) {
  var isWebkit = !!navigator.webkitGetUserMedia;

  switch (callType) {
    case CallType.Voice:
      return {
        audio: {
          deviceId: audioInput ? {
            ideal: audioInput
          } : undefined
        },
        video: false
      };

    case CallType.Video:
      return {
        audio: {
          deviceId: audioInput ? {
            ideal: audioInput
          } : undefined
        },
        video: {
          deviceId: videoInput ? {
            ideal: videoInput
          } : undefined,

          /* We want 640x360.  Chrome will give it only if we ask exactly,
             FF refuses entirely if we ask exactly, so have to ask for ideal
             instead
             XXX: Is this still true?
           */
          width: isWebkit ? {
            exact: 640
          } : {
            ideal: 640
          },
          height: isWebkit ? {
            exact: 360
          } : {
            ideal: 360
          }
        }
      };
  }
}

var audioOutput;
var audioInput;
var videoInput;
/**
 * Set an audio output device to use for MatrixCalls
 * @function
 * @param {string=} deviceId the identifier for the device
 * undefined treated as unset
 */

function setAudioOutput(deviceId) {
  audioOutput = deviceId;
}
/**
 * Set an audio input device to use for MatrixCalls
 * @function
 * @param {string=} deviceId the identifier for the device
 * undefined treated as unset
 */


function setAudioInput(deviceId) {
  audioInput = deviceId;
}
/**
 * Set a video input device to use for MatrixCalls
 * @function
 * @param {string=} deviceId the identifier for the device
 * undefined treated as unset
 */


function setVideoInput(deviceId) {
  videoInput = deviceId;
}
/**
 * Create a new Matrix call for the browser.
 * @param {MatrixClient} client The client instance to use.
 * @param {string} roomId The room the call is in.
 * @param {Object?} options DEPRECATED optional options map.
 * @param {boolean} options.forceTURN DEPRECATED whether relay through TURN should be
 * forced. This option is deprecated - use opts.forceTURN when creating the matrix client
 * since it's only possible to set this option on outbound calls.
 * @return {MatrixCall} the call or null if the browser doesn't support calling.
 */


function createNewMatrixCall(client, roomId, options) {
  // typeof prevents Node from erroring on an undefined reference
  if (typeof window === 'undefined' || typeof document === 'undefined') {
    _logger.logger.info("No window or document object: WebRTC is not supported in this environment");

    return null;
  } // Firefox throws on so little as accessing the RTCPeerConnection when operating in
  // a secure mode. There's some information at https://bugzilla.mozilla.org/show_bug.cgi?id=1542616
  // though the concern is that the browser throwing a SecurityError will brick the
  // client creation process.


  try {
    var supported = Boolean(window.RTCPeerConnection || window.RTCSessionDescription || window.RTCIceCandidate || navigator.mediaDevices);

    if (!supported) {
      _logger.logger.error("WebRTC is not supported in this browser / environment");

      return null;
    }
  } catch (e) {
    _logger.logger.error("Exception thrown when trying to access WebRTC", e);

    return null;
  }

  var optionsForceTURN = options ? options.forceTURN : false;
  var opts = {
    client: client,
    roomId: roomId,
    turnServers: client.getTurnServers(),
    // call level options
    forceTURN: client._forceTURN || optionsForceTURN
  };
  return new MatrixCall(opts);
}